//+------------------------------------------------------------------+
//| rsi sto cci   zone                                               |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//mod 2008 fxtsd   ki

#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Sienna
#property indicator_color2 Red
#property indicator_color3 Teal
#property indicator_color4 ForestGreen
#property indicator_color5 Blue
#property indicator_color6 RoyalBlue

#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 2




#property indicator_level1  200
#property indicator_level2  100
#property indicator_level3  50
#property indicator_level4  -50
#property indicator_level5  -100
#property indicator_level6  -200

#property indicator_levelstyle 2
#property indicator_levelcolor DarkOliveGreen



extern int RSI_period      = 9;
extern int RSI_price       = 0;
extern int MA_RSI_period   = 5;
extern int MA_RSI_method   = 1;

extern int CCI_period      = 34;
extern int CCI_price       = 0;
extern int MA_CCI_period   = 5;
extern int MA_CCI_method   = 1;

extern int StoK_period    = 14;
extern int StoD_period    = 3;
extern int StoSl_period   = 3;
extern int StoMA_method   = 0;
extern int StoPrice_field = 1;



extern string note_method_ = "MAmethod: SMA0 EMA1 SMMA2 LWMA3"; 
extern string price_field_ = "0- Low/High  1- Close/Close" ;
extern string line_mode___ = "0- main 1- signal line" ;

extern bool   ShowZoneLevels    = true;  
extern double ZLevel1        = 70; // zone-mladen's laguerre
extern double ZLevel2        = 50;
extern double ZLevel3        = 30;
extern color  ZLevel1Color   = C'0,0,71';
extern color  ZLevel2Color   = C'33,56,56';
extern color  ZLevel3Color   = C'48,0,0';


extern int LineLevel1        = 80; // 
extern int LineLevel2        = 50; // 
extern int LineLevel3        = 20; // 

extern double RSI_STO_Multiplyer        = 2.0; // 

//---- 

double RSIBuffer[];
double MARSIBuffer[];

double StoKBuffer[];
double StoDBuffer[];

double CCIBuffer[];
double MACCIBuffer[];

string short_name;

//+------

int init()
  {
//---- 

   IndicatorBuffers(6);
   
  
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);

     
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
  
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);

   short_name=MakeUniqueName("RSI("+RSI_period+","+MA_RSI_period+") STO("+StoK_period+","+StoD_period+","+StoSl_period+") CCI("+CCI_period+","+MA_CCI_period+")  "," ");
   IndicatorShortName(short_name);


   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"MA_RSI");
   SetIndexLabel(2,"StoK");
   SetIndexLabel(3,"StoD");
   SetIndexLabel(4,"CCI");
   SetIndexLabel(5,"MA_CCI");
   
   SetIndexBuffer(0,RSIBuffer);
   SetIndexBuffer(1,MARSIBuffer);
   
   SetIndexBuffer(2,StoKBuffer);
   SetIndexBuffer(3,StoDBuffer);

   SetIndexBuffer(4,CCIBuffer);
   SetIndexBuffer(5,MACCIBuffer);
 


   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
//+------  
int deinit()
  {   
   ObjectDelete(short_name+"_t1");ObjectDelete(short_name+"_t2");ObjectDelete(short_name+"_t3");
   ObjectDelete(short_name+"L1"); ObjectDelete(short_name+"L2"); ObjectDelete(short_name+"L3");

   DeleteBounds();

   return(0);
   }
//+------

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double X=RSI_STO_Multiplyer;

   int i,limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
      for (i=limit;i>=0;i--)
     {       
   StoKBuffer[i]=(iStochastic(NULL,0,StoK_period,StoD_period,StoSl_period,StoMA_method,StoPrice_field,MODE_MAIN,i)-50)*X;
   StoDBuffer[i]=(iStochastic(NULL,0,StoK_period,StoD_period,StoSl_period,StoMA_method,StoPrice_field,MODE_SIGNAL,i)-50)*X;
     }

      for (i=limit;i>=0;i--)
      RSIBuffer[i]     = (iRSI(NULL,0,RSI_period,RSI_price,i)-50)*X;

      for (i=limit;i>=0;i--)
      MARSIBuffer[i]   = iMAOnArray(RSIBuffer,0,MA_RSI_period,0,MA_RSI_method,i); 


      for (i=limit;i>=0;i--)
      CCIBuffer[i]     = iCCI(NULL,0,CCI_period,CCI_price,i);

      for (i=limit;i>=0;i--)
      MACCIBuffer[i]   = iMAOnArray(CCIBuffer,0,MA_CCI_period,0,MA_CCI_method,i); 

 //
 //
 
    ObjectDelete(short_name+"L1");
if(ObjectFind  (short_name+"L1")!=0) 
        {
   ObjectCreate(short_name+"L1", OBJ_TREND,WindowFind(short_name),0, (LineLevel1-50)*X, Time[0],(LineLevel1-50)*X);
   ObjectSet   (short_name+"L1", OBJPROP_COLOR, SlateBlue);
   ObjectSet   (short_name+"L1", OBJPROP_STYLE, 2);
   ObjectSet   (short_name+"L1", OBJPROP_RAY, false);
        }

 
 
 
   ObjectDelete(short_name+"L2");
if(ObjectFind  (short_name+"L2")!=0) 
        {
   ObjectCreate(short_name+"L2", OBJ_TREND,WindowFind(short_name),0, (LineLevel2-50)*X, Time[0],(LineLevel2-50)*X);
   ObjectSet   (short_name+"L2", OBJPROP_COLOR, Purple);
   ObjectSet   (short_name+"L2", OBJPROP_STYLE, 2);
   ObjectSet   (short_name+"L2", OBJPROP_RAY, false);
        }

   
   ObjectDelete(short_name+"L3");
if(ObjectFind  (short_name+"L3")!=0) 
        {
   ObjectCreate(short_name+"L3", OBJ_TREND,WindowFind(short_name),0, (LineLevel3-50)*X, Time[0],(LineLevel3-50)*X);
   ObjectSet   (short_name+"L3", OBJPROP_COLOR, SlateBlue);
   ObjectSet   (short_name+"L3", OBJPROP_STYLE, 2);
   ObjectSet   (short_name+"L3", OBJPROP_RAY, false);
         }



//   

      
      ObjectDelete (short_name+"_t1");
   if(ObjectFind   (short_name+"_t1")!=0) 
        {
      ObjectCreate (short_name+"_t1", OBJ_TEXT,WindowFind(short_name), Time[0],(LineLevel1-50)*X+4);
      ObjectSetText(short_name+"_t1","                         sto rsi "+LineLevel1+"",7, "Tahoma Narrow",BlueViolet);
        }
         else
         ObjectMove (short_name+"_t1", 0, Time[0], (LineLevel1-50)*X+4); 
         

      
      ObjectDelete (short_name+"_t2");
   if(ObjectFind   (short_name+"_t2")!=0) 
        {
      ObjectCreate (short_name+"_t2", OBJ_TEXT,WindowFind(short_name), Time[0],(LineLevel2-50)*X+4);
      ObjectSetText(short_name+"_t2","                         sto rsi "+LineLevel2+"",7, "Tahoma Narrow",BlueViolet);
        }
         else
         ObjectMove(short_name+"_t2", 0, Time[0], LineLevel2+4); 
         

   
      
      ObjectDelete(short_name+"_t3");
   if(ObjectFind  (short_name+"_t3")!=0) 
        {
      ObjectCreate (short_name+"_t3", OBJ_TEXT,WindowFind(short_name), Time[0],(LineLevel3-50)*X+4);
      ObjectSetText(short_name+"_t3","                         sto rsi "+LineLevel3+"",7, "Tahoma Narrow",BlueViolet);
        }
         else
         ObjectMove(short_name+"_t3", 0, Time[0], (LineLevel3-50)*X); 
         



    if (ShowZoneLevels) UpdateBounds();
  
   
   return(0);
  }


//
//
//
//
//

void DeleteBounds()
{
   ObjectDelete(short_name+"-1");
   ObjectDelete(short_name+"-2");
   ObjectDelete(short_name+"-3");
}
void UpdateBounds()
{
 double X=RSI_STO_Multiplyer;
   if (ZLevel1 != 0) SetUpBound(short_name+"-1",(100    -50)*X     , (ZLevel1-50)*X     , ZLevel1Color);
   if (ZLevel2 != 0) SetUpBound(short_name+"-2",(ZLevel2-50)*X*1.01, (ZLevel2-50)*X*0.99, ZLevel2Color);
   if (ZLevel3 != 0) SetUpBound(short_name+"-3",(       -50)*X     , (ZLevel3-50)*X     , ZLevel3Color);
}

void SetUpBound(string name, double up, double down,color theColor)
{
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_RECTANGLE,WindowFind(short_name),0,0);
         ObjectSet(name,OBJPROP_PRICE1,up);
         ObjectSet(name,OBJPROP_PRICE2,down);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_BACK,true);
         ObjectSet(name,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name,OBJPROP_TIME2,    iTime(NULL,0,0));
}


//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

