//+------------------------------------------------------------------+
//|                                        Sexy Stochastics v202.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, BoxingisLife , Melphoos & Nondiscloseure00 @ ForexFactory.com"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

// Edits by Nondisclosure00.
// Errata:
// Added visual indicators for te Stoch lines.
// Added placement of visual indicators.
// Cleaned up formatting of code for ease of reading.

// Bug List:
// None that I'm aware of.  I've assumed that the triggers are correct.  They match the pdf v1.1.

// ToDo:
// Add the NonlagMA indicator.
// Add the Sto5 Indicator.
// Convert into an EA.

// Get level to be set (ie. 40, 30, 80, etc.).  

//---- input parameters
extern string    CornerString = "Select corner. 0=Upper Left, 1=Upper Right, 2=lower left , 3=lower right";
extern int       Global_Corner=3;
extern string    DistanceFigureXY = "Select the spacing from the corner";
extern int       Xdist = 3;
extern int       Ydist = 3;
extern int       Stoch5Level = 70;

int Stoch5KPeriod =5;
int Stoch5DPeriod =3;
int Stoch5SlowPeriod =3;
int Stoch20KPeriod =20; 
int Stoch20DPeriod =10;
int Stoch20SlowPeriod =20;
int Stoch50KPeriod =50; 
int Stoch50DPeriod =10; 
int Stoch50SlowPeriod =20; 

int     Price          = 0;
int     Length         = 9;
int     Displace       = 0;
int     Filter         = 3;
int     Color          = 1;
int     ColorBarBack   = 0;
double  Deviation      = 0;         


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  }
//---- indicators
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//   ObjectDelete("AlarmDown");
//   ObjectDelete("AlarmUp");
//   ObjectDelete("AlarmFlat");
//   ObjectDelete("NonLagNos");
      ObjectDelete("Stoch2050");
      ObjectDelete("Stoch2020");
      ObjectDelete("NonLagTrend"); 
      ObjectDelete("Stoch55");
      ObjectDelete("Stoch5Level");
        
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
     double Stoch5Signal = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,0);
     double Stoch5Main = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,0);
     double Stoch5SignalLastTick = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,1);
     double Stoch5MainLastTick = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,1);
     double Stoch5Signal2TicksAgo = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,2);
     double Stoch5Main2TicksAgo = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,2);
     double Stoch20Signal = iStochastic(Symbol(),0,Stoch20KPeriod,Stoch20DPeriod,Stoch20SlowPeriod,MODE_SMA,0,MODE_SIGNAL,1);
     double Stoch20Main = iStochastic(Symbol(),0,Stoch20KPeriod,Stoch20DPeriod,Stoch20SlowPeriod,MODE_SMA,0,MODE_MAIN,1);
     double Stoch20SignalLastTick = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,1);
     double Stoch20MainLastTick = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,1);
     double Stoch20Signal2TicksAgo = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,2);
     double Stoch20Main2TicksAgo = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,2);
     double Stoch50Signal = iStochastic(Symbol(),0,Stoch50KPeriod,Stoch50DPeriod,Stoch50SlowPeriod,MODE_SMA,0,MODE_SIGNAL,1);
     double Stoch50Main = iStochastic(Symbol(),0,Stoch50KPeriod,Stoch50DPeriod,Stoch50SlowPeriod,MODE_SMA,0,MODE_MAIN,1);
     double Stoch50SignalLastTick = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,1);
     double Stoch50MainLastTick = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,1);
     double Stoch50Signal2TicksAgo = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_SIGNAL,2);
     double Stoch50Main2TicksAgo = iStochastic(Symbol(),0,Stoch5KPeriod,Stoch5DPeriod,Stoch5SlowPeriod,MODE_SMA,0,MODE_MAIN,2);
//     int way = 2;
     double NonLagTrend = iCustom(NULL,0,"NonLagMA_v5",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,3,1);

     if(Stoch20Main>Stoch50Main)
     {
           ObjectDelete("Stoch2050");
           ObjectCreate("Stoch2050", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch2050","First Indication is UP",9, "Verdana", DodgerBlue);
           ObjectSet("Stoch2050", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch2050", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("Stoch2050", OBJPROP_YDISTANCE, Ydist);
     } 
     
     if(Stoch20Main>Stoch20Signal)
     {
           ObjectDelete("Stoch2020");
           ObjectCreate("Stoch2020", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch2020","Second Indication is UP",9, "Verdana", DodgerBlue);
           ObjectSet("Stoch2020", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch2020", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("Stoch2020", OBJPROP_YDISTANCE, Ydist + 12);
     } 
     
     if(NonLagTrend>0)
     {
           ObjectDelete("NonLagTrend");
           ObjectCreate("NonLagTrend", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("NonLagTrend","Third Indication is UP",9, "Verdana", DodgerBlue);
           ObjectSet("NonLagTrend", OBJPROP_CORNER, Global_Corner);
           ObjectSet("NonLagTrend", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("NonLagTrend", OBJPROP_YDISTANCE, Ydist + 24);
     } 
     
     if(Stoch5Main>Stoch5Signal)
     {
           ObjectDelete("Stoch55");
           ObjectCreate("Stoch55", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch55","Stoch5Main is Higher than its signal line",9, "Verdana", DodgerBlue);
           ObjectSet("Stoch55", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch55", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("Stoch55", OBJPROP_YDISTANCE, Ydist + 36);
     } 

     if(Stoch5Main>Stoch5Level)
     {
           ObjectDelete("Stoch5Level");
           ObjectCreate("Stoch5Level", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch5Level","Stoch5Main is Higher than your seeting of " + Stoch5Level,9, "Verdana", DodgerBlue);
           ObjectSet("Stoch5Level", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch5Level", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("StochLevel", OBJPROP_YDISTANCE, Ydist + 40);
     } 
     
     
//        way = 0;  // Trend going up.  Take trade at end of candle!  need to find out how to figure that.
            

     if(Stoch20Main<Stoch50Main)
     {
           ObjectDelete("Stoch2050");
           ObjectCreate("Stoch2050", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch2050","First Indication is DOWN",9, "Verdana", Red);
           ObjectSet("Stoch2050", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch2050", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("Stoch2050", OBJPROP_YDISTANCE, Ydist);
     } 
     
     if(Stoch20Main<Stoch20Signal)
     {
           ObjectDelete("Stoch2020");
           ObjectCreate("Stoch2020", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch2020","Second Indication is DOWN",9, "Verdana", Red);
           ObjectSet("Stoch2020", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch2020", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("Stoch2020", OBJPROP_YDISTANCE, Ydist + 12);
     } 
     
     if(NonLagTrend<0)
     {
           ObjectDelete("NonLagTrend");
           ObjectCreate("NonLagTrend", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("NonLagTrend","Third Indication is DOWN",9, "Verdana", Red);
           ObjectSet("NonLagTrend", OBJPROP_CORNER, Global_Corner);
           ObjectSet("NonLagTrend", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("NonLagTrend", OBJPROP_YDISTANCE, Ydist + 24);
     } 
     
     if(Stoch5Main<Stoch5Signal)
     {
           ObjectDelete("Stoch55");
           ObjectCreate("Stoch55", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch55","Stoch5Main is Less than its signal line",9, "Verdana", Red);
           ObjectSet("Stoch55", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch55", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("Stoch55", OBJPROP_YDISTANCE, Ydist + 36);
     } 

     if(Stoch5Main<Stoch5Level)
     {
           ObjectDelete("Stoch5Level");
           ObjectCreate("Stoch5Level", OBJ_LABEL, 0, 0, 0);
           ObjectSetText("Stoch5Level","Stoch5Main is Less than your seeting of " + Stoch5Level,9, "Verdana", Red);
           ObjectSet("Stoch5Level", OBJPROP_CORNER, Global_Corner);
           ObjectSet("Stoch5Level", OBJPROP_XDISTANCE, Xdist);
           ObjectSet("StochLevel", OBJPROP_YDISTANCE, Ydist + 40);
     } 
     
     
//        way = 1;  // Trend going down.  Take trade at end of candle!  need to find out how to figure that.
     
//     way = 2;  // No trends worth noting.  Bummer!
//     switch(way)
//     {
//        case 0:
//           PlaySound("alert.wav");
//           ObjectDelete("AlarmDown");
//           ObjectDelete("AlarmFlat");
//           ObjectCreate("AlarmUp", OBJ_LABEL, 0, 0, 0);
//           ObjectSetText("AlarmUp","Cross Up Alarm!",15, "Verdana", DodgerBlue);
//           ObjectSet("AlarmUp", OBJPROP_CORNER, Global_Corner);
//           ObjectSet("AlarmUp", OBJPROP_XDISTANCE, Xdist);
//           ObjectSet("AlarmUp", OBJPROP_YDISTANCE, Ydist);
//           break;
//        case 1:
//           PlaySound("alert.wav");
//           ObjectDelete("AlarmUp");
//           ObjectDelete("AlarmFlat");
//           ObjectCreate("AlarmDown", OBJ_LABEL, 0, 0, 0);
//           ObjectSetText("AlarmDown","Cross Down Alarm!",15, "Verdana", Red);
//           ObjectSet("AlarmDown", OBJPROP_CORNER, Global_Corner);
//           ObjectSet("AlarmDown", OBJPROP_XDISTANCE, Xdist);
//           ObjectSet("AlarmDown", OBJPROP_YDISTANCE, Ydist);
//           break;
//        case 2:
//           ObjectDelete("AlarmUp");
//           ObjectDelete("AlarmDown");
//           ObjectCreate("AlarmFlat", OBJ_LABEL, 0, 0, 0);
//           ObjectSetText("AlarmFlat","No trends worth noting.  Bummer!",9, "Verdana", Orange);
//           ObjectSet("AlarmFlat", OBJPROP_CORNER, Global_Corner);
//           ObjectSet("AlarmFlat", OBJPROP_XDISTANCE, Xdist);
//           ObjectSet("AlarmFlat", OBJPROP_YDISTANCE, Ydist);
//           break;
//     }
//     ObjectCreate("NonLagNos", OBJ_LABEL, 0, 0, 0);
//     ObjectSetText("NonLagNos","NonLagTrend=" + NonLagTrend,9, "Verdana", White);
//     ObjectSet("NonLagNos", OBJPROP_CORNER, 0);
//     ObjectSet("NonLagNos", OBJPROP_XDISTANCE, Xdist);
//     ObjectSet("NonLagNos", OBJPROP_YDISTANCE, Ydist);     
   return(0);
}

