//+------------------------------------------------------------------+
//|                                                   Stoch_onTF.mq4 |
//|                                                                  |
//|                                 Yahoo group  |
//|                                              i7hornet@yahoo.com  |
//+------------------------------------------------------------------+
#property copyright "i7hornet@yahoo.com"

#property indicator_separate_window
#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_levelcolor ForestGreen
#property indicator_level1 20
#property indicator_level2 80
#property indicator_levelwidth 2
//----- indicator parameters 
extern int SPrice=0; //0 - Low/High ,1 - Close/Close.
extern int Method=0;
extern int KPeriod=5;
extern int Slowing=3;
extern int DPeriod=1;
extern string Type_TF="M1=1 M5=5 M15=15 M30=30 H1=60 H4=240 D1=1440 W1=10080 MN1=43200";
extern int TF=240; 
         
double MainBuffer[];
//-----
int CountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;
//----- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(KPeriod<5) KPeriod=5;
   draw_begin=KPeriod-1;
   IndicatorShortName("Stoch_"+TF+"_("+KPeriod+","+Slowing+")");
   SetIndexDrawBegin(0,draw_begin);
//----- indicator buffers mapping
   SetIndexBuffer(0,MainBuffer);
//----- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=TF) return(0);
   CountedBars=IndicatorCounted();
//----- check for possible errors
   if (CountedBars<0) return(-1);
// last counted bar will be recounted
   if (CountedBars>0) CountedBars--;
//-----
   for (int i=Bars-CountedBars-1; i >= 0; i--) 
   {
      datetime tofnow = Time[i]; 
      int j = iBarShift(Symbol(),TF,tofnow,false);
      MainBuffer[i] = iStochastic(Symbol(),TF,KPeriod,1,Slowing,Method,SPrice,MODE_MAIN,j);
   }
//-----
   return(0);
  }

