//+------------------------------------------------------------------+
//|                                       Color Stochastic v1.02.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
//|                    Color Stochastic v1.02.mq4 (copyright:mladen) |
//|	      #MTF Stochastic v2.0.mq4 (copyright:Christof Risch (iya))	 |
//|                                                                  |
//| 2011 MJ   used also ideas/Code from the two mentioned above      |
//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers  7
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_color1 LightSlateGray //Stochastick K%
#property indicator_color2 LightSlateGray //Stochastick D%
#property indicator_color3 Red //Overbought
#property indicator_color4 Blue //Oversold 
#property indicator_color5 Orange //Uptrend
#property indicator_color6 DeepSkyBlue //Downtrend
#property indicator_color7 LightSlateGray  // SameDirection - if ShowOnlyDirection=false ( in Overbought and Oversold area SameDirection color disregarded)
#property indicator_width1 3
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3
#property indicator_width7 3


//--- Prefix for objects so we can delete them later 
extern   string _Info="== set a unique prefix for objects ==";
extern string UniquePrefix="UStochastic_mj";

//---- parameters
extern string ______________0____________ = "==Stochastic settings==";
extern string note1 = "Chart Time Frame";
extern string note2 = "0=current time frame";
extern string note3 = "1=M1, 5=M5, 15=M15, 30=M30";
extern string note4 = "60=H1, 240=H4, 1440=D1";
extern string note5 = "10080=W1, 43200=MN1";
extern int	StochTimeFrame	= 5;		// {1=M1, 5=M5, 15=M15, ..., 1440=D1, 10080=W1, 43200=MN1}
extern string note6 = "Stochastic settings";

extern int       KPeriod  = 14;
extern int       Slowing =  3;         
extern int       DPeriod =  3; 
extern string    Attention_DPeriod   = "Only Enable it  if you need it"; 
extern bool      enableDLine=false;


extern string note7 = "0=sma, 1=ema, 2=smma, 3=lwma";
extern int       MAMethod    =   0;
extern string note8 = "0=high/low, 1=close/close";
extern int       PriceField  =   0;
extern string note9 = "overbought level";
extern int       overBought  =  80;
extern string note10 = "oversold level";
extern int       overSold    =  20;
extern string ______________1____________ = "==Stochastic Options==";
extern bool ShowBars=false;
extern bool ConsiderColorOverBoughtSold=false;
extern string note11 = "For Line Or Bar: Interpolation";
extern string note12 = "Note: ifUseInterpolation=true";
extern string note13 = "PastData are always ReAdjusted";
extern bool UseInterpolation=true;

extern string note14 = "==ReAdjustDataForPastBars==";
extern string note15 = "works on Bars and Line display";
extern bool ReAdjustDataForPastBars=true;

extern bool DontDisplayValuesAndSettings=false;
extern bool DisableLowerStochPeriodAlert=false;

extern string ______________2____________= "==Alert==";
extern bool      alertsOn      = false;
extern bool      alertsMessage = true;
extern bool      alertsSound   = true;
extern bool      alertsEmail   = true;
extern string SoundFileName="alert.wav";

extern string note16 = "0 Not to include One";
extern string note17 = "Active: above 0 - below 100";
extern string note18="==ALERTS CROSSES ABOVE==";
extern double Alert1_CrossesAbove=0;
extern double Alert2_CrossesAbove=0;
extern string note19="==ALERTS CROSSES BELOW==";
extern double Alert1_CrossesBelow=0;
extern double Alert2_CrossesBelow=0;



//---- buffers
double   KFull[];
double   DFull[];
double SameDirection[];
double Uptrend[];
double Downtrend[];
double OverBought[];
double OverSold[];


double   StochTimeFrame_KFull[];
double   StochTimeFrame_DFull[];
datetime StochTimeArray[];
int Size_StochStochTimeArray;
//--------



int ChartBarsPerStochTimeFrame;
double percentK;
double percentK_previous;
string	IndicatorName;

int limit;

   
bool alertflag=0;
string _errorStr="NONE";
string _infoStr;
bool _LowerStochPeriod=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
    {

    // Check StochTimeFrame setting not smaller than current 
    if(StochTimeFrame < Period() && StochTimeFrame != 0)
        {
        if (DisableLowerStochPeriodAlert)
            {
            _LowerStochPeriod=true;
            }
        else
            {
            _errorStr=UniquePrefix+": ERROR \"StochTimeFrame\" is less than Chart Period.";
            if(alertflag == 0) {Alert(_errorStr); PlaySound("alert.wav"); alertflag = 1;}
            return;
            }
        } 
// Check StochTimeFrame one of the possible for MT4          
    if (!(StochTimeFrame == 0 || StochTimeFrame == 1 || StochTimeFrame == 5 || StochTimeFrame == 15 || StochTimeFrame == 30 || StochTimeFrame == 60 || StochTimeFrame == 240 || StochTimeFrame == 1440 || StochTimeFrame == 10080 || StochTimeFrame == 43200))
        {
        _errorStr=UniquePrefix+": ERROR \"StochTimeFrame\" : < " +StochTimeFrame+ " > is not one of the possible MT4 TimeFrames.";
        if(alertflag == 0) {Alert(_errorStr); PlaySound("alert.wav"); alertflag = 1;}
        return;
        }
 

// Check alertsOn
    if (alertsOn)
        {
        //Alert correct input
        if ((Alert1_CrossesAbove >= 100 || Alert1_CrossesAbove < 0) || (Alert2_CrossesAbove >= 100 || Alert2_CrossesAbove < 0) || (Alert1_CrossesBelow >= 100 || Alert1_CrossesBelow < 0)  || (Alert2_CrossesBelow >= 100 || Alert2_CrossesBelow < 0) )
            {
            _errorStr=UniquePrefix+": ERROR \"StochTimeFrame\": "+StochTimeFrame+" --> ALL Alerts settings must be 0 or above and less than 100.";
            if(alertflag == 0) {Alert(_errorStr); PlaySound("alert.wav"); alertflag = 1;}
            return;
            }
        }


//============Auto Adjust sensible settings
    // AVOID Extra calculation: UseInterpolation MAKES ONLY SENSE IF: Different MTF Period: StochTimeFrame -> ChartTimeFrame 
    if (UseInterpolation && (StochTimeFrame == 0 || StochTimeFrame == Period()))
        {
        UseInterpolation=false;
        }
 
    // AVOID Extra calculation; D% calculation makes no sense with Bar display
    if (ShowBars && enableDLine)
        {
        enableDLine=false;
        }
//============END Auto Adjust sensible settings


//---- name for DataWindow and indicator subwindow label
    if (DontDisplayValuesAndSettings)
        {
        IndicatorShortName(" "); 
        }
	else
	   {
        IndicatorName = UniquePrefix+ " ("+TimeFrameToString(StochTimeFrame)+"("+KPeriod+","+DPeriod+","+Slowing+") "+maDescription(MAMethod)+"|"+priceDescription(PriceField)+" | ALERTS:"+alertsOnDescription(alertsOn)+")";
        IndicatorShortName(IndicatorName); 
        }
        
    IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
        
        
//---- Buffer Assignment
    if (ShowBars)
        {
        SetIndexStyle(0,DRAW_NONE);
        SetIndexBuffer(0,KFull);
        SetIndexLabel(0,""); // Bars we never display Values
        
        SetIndexStyle(1,DRAW_NONE);
        SetIndexBuffer(1,DFull);
        SetIndexLabel(1,""); // Bars we never display Values
             
        SetIndexStyle(2,DRAW_HISTOGRAM);
        SetIndexBuffer(2,OverBought);
        SetIndexLabel(2,""); 
         
        SetIndexStyle(3,DRAW_HISTOGRAM);
        SetIndexBuffer(3,OverSold);
        SetIndexLabel(3,"");  

        SetIndexStyle(4,DRAW_HISTOGRAM);
        SetIndexBuffer(4,Uptrend);
        SetIndexLabel(4,"");

        SetIndexStyle(5,DRAW_HISTOGRAM);
        SetIndexBuffer(5,Downtrend);
        SetIndexLabel(5,"");

        SetIndexStyle(6,DRAW_HISTOGRAM);
        SetIndexBuffer(6,SameDirection);
        SetIndexLabel(6,"");

        }
    // normal Line Display
    else
        {
        SetIndexStyle(0,DRAW_LINE);
        SetIndexBuffer(0,KFull);
        if (DontDisplayValuesAndSettings) SetIndexLabel(0,"");
          
        if (enableDLine)
            {
            SetIndexStyle(1,DRAW_LINE);
            }
        else
            {
            SetIndexStyle(1,DRAW_NONE);
            }
        SetIndexBuffer(1,DFull);
        if (DontDisplayValuesAndSettings) SetIndexLabel(1,"");
                     
        SetIndexStyle(2,DRAW_NONE);
        SetIndexBuffer(2,OverBought);
        if (DontDisplayValuesAndSettings) SetIndexLabel(2,""); 
         
        SetIndexStyle(3,DRAW_NONE);
        SetIndexBuffer(3,OverSold);
        if (DontDisplayValuesAndSettings) SetIndexLabel(3,"");  

        SetIndexStyle(4,DRAW_NONE);
        SetIndexBuffer(4,Uptrend);
        if (DontDisplayValuesAndSettings) SetIndexLabel(4,"");

        SetIndexStyle(5,DRAW_NONE);
        SetIndexBuffer(5,Downtrend);
        if (DontDisplayValuesAndSettings) SetIndexLabel(5,"");

        SetIndexStyle(6,DRAW_NONE);
        SetIndexBuffer(6,SameDirection);
        if (DontDisplayValuesAndSettings) SetIndexLabel(6,"");
        }
        


    //===========================
    ChartBarsPerStochTimeFrame=StochTimeFrame/Period();
//----
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
    {
    if (_errorStr!="NONE")
        {  
        IndicatorShortName(UniquePrefix+": ERROR ERROR");   
        if(alertflag == 0) {Alert(_errorStr); alertflag = 1;}
        return;
        }
     if (_LowerStochPeriod)
        {
        IndicatorShortName(UniquePrefix+": LowerStochPeriod NOT Displayed"); 
        return;
        }   

    int counted_bars=IndicatorCounted();
    //---- check for possible errors
    if(counted_bars<0) return(-1);
    //---- the last counted bar will be recounted
    if(counted_bars>0) counted_bars--;
    
    
    if (ReAdjustDataForPastBars)
        {
        limit = Bars-counted_bars+StochTimeFrame/Period();
        }
    else
        {
        limit = Bars-counted_bars;
        } 

   		     
   //-----------------------------------------------------------------------

   
    ArrayCopySeries(StochTimeArray,MODE_TIME,Symbol(),StochTimeFrame);
    Size_StochStochTimeArray = ArraySize(StochTimeArray);   
    ArrayResize(StochTimeFrame_KFull,Size_StochStochTimeArray);
    ArrayResize(StochTimeFrame_DFull,Size_StochStochTimeArray);

    int i,y;
    
     //FOR LINES WE HAVE TO DO SIMPLE
    if (!ShowBars)
        {  
        //==============KFULL
        doStochasticCalculation(MODE_MAIN, StochTimeFrame_KFull, KFull);
        //==============DFULL
        if (enableDLine)
            {
            doStochasticCalculation(MODE_SIGNAL, StochTimeFrame_DFull, DFull);
            }
            
        if (alertsOn)
            {   
            // DO ALERTS
            if (KFull[0]>Alert1_CrossesAbove && KFull[1]<=Alert1_CrossesAbove) doAlert(" | Alert1_CrossesAbove " +Alert1_CrossesAbove);
            if (KFull[0]>Alert2_CrossesAbove && KFull[1]<=Alert2_CrossesAbove) doAlert(" Alert2_CrossesAbove " +Alert2_CrossesAbove);
        
            if (KFull[0]<Alert1_CrossesBelow && KFull[1]>=Alert1_CrossesBelow) doAlert(" | Alert1_CrossesBelow " +Alert1_CrossesBelow);
            if (KFull[0]<Alert2_CrossesBelow && KFull[1]>=Alert2_CrossesBelow) doAlert(" | Alert2_CrossesBelow " +Alert2_CrossesBelow);
            }
        }
    // SHOW BARS
    else
        {  
        // IF WE USE INTERPOLATION
        if (UseInterpolation)
            {  
            // do KFULL
            //==============KFULL
            doStochasticCalculation(MODE_MAIN, StochTimeFrame_KFull, KFull);
            
            if (alertsOn)
                {   
                // DO ALERTS
                if (KFull[0]>Alert1_CrossesAbove && KFull[1]<=Alert1_CrossesAbove) doAlert(" | Alert1_CrossesAbove " +Alert1_CrossesAbove);
                if (KFull[0]>Alert2_CrossesAbove && KFull[1]<=Alert2_CrossesAbove) doAlert(" Alert2_CrossesAbove " +Alert2_CrossesAbove);
        
                if (KFull[0]<Alert1_CrossesBelow && KFull[1]>=Alert1_CrossesBelow) doAlert(" | Alert1_CrossesBelow " +Alert1_CrossesBelow);
                if (KFull[0]<Alert2_CrossesBelow && KFull[1]>=Alert2_CrossesBelow) doAlert(" | Alert2_CrossesBelow " +Alert2_CrossesBelow);
                }
                        
            //  Now we just assign the colors
            for(i=0;i<limit-1;i++)
                {
                percentK = KFull[i];
                percentK_previous = KFull[i+1];

                OverBought[i] = EMPTY_VALUE;  
                OverSold[i] = EMPTY_VALUE;                 
                Uptrend[i] = EMPTY_VALUE;                
                Downtrend[i] = EMPTY_VALUE;                
                SameDirection[i] = EMPTY_VALUE;    


                 //==ConsiderColorOverBoughtSold
                 if (ConsiderColorOverBoughtSold)
                     {
                     if (percentK > overBought)
                         {
                         OverBought[i] = 100;
                         }
                     else if (percentK < overSold)
                         {
                         OverSold[i] = 100;
                         }
                     else
                         {
                         if (percentK > percentK_previous)
                             {
                             Uptrend[i] = 100;    
                             }
                         else if (percentK < percentK_previous)
                             {
                             Downtrend[i] = 100;    
                             }
                         else if (percentK == percentK_previous)
                             {
                             SameDirection[i] = 100;    
                             }                
                         }  
                     }
                //==Only Direction Color
                else
                     {
                     if (percentK > percentK_previous)
                         {
                         Uptrend[i] = 100;    
                         }
                     else if (percentK < percentK_previous)
                         {
                         Downtrend[i] = 100;    
                         }
                     else if (percentK == percentK_previous)
                         {
                         SameDirection[i] = 100;    
                         }  
                     }                
                } 
            }
        // ===========BARS NO UseInterpolation (MORE WORK)
        else
            {
            // Same Period: StochTimeFrame -> ChartTimeFrame
            if (StochTimeFrame == Period())
                {
                for(i=0;i<limit-1;i++)
                    {
                    percentK = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i);
                    percentK_previous = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i+1);

                    
                    // DO ALERTS
                    if (alertsOn && i==0)
                        {
                        if (percentK>Alert1_CrossesAbove && percentK_previous<=Alert1_CrossesAbove) doAlert(" | Alert1_CrossesAbove " +Alert1_CrossesAbove);
                        if (percentK>Alert2_CrossesAbove && percentK_previous<=Alert2_CrossesAbove) doAlert(" Alert2_CrossesAbove " +Alert2_CrossesAbove);
                        
                        if (percentK<Alert1_CrossesBelow && percentK_previous>=Alert1_CrossesBelow) doAlert(" | Alert1_CrossesBelow " +Alert1_CrossesBelow);
                        if (percentK<Alert2_CrossesBelow && percentK_previous>=Alert2_CrossesBelow) doAlert(" | Alert2_CrossesBelow " +Alert2_CrossesBelow);
                        }
                        


                    //  Now we just assign the colors
                    OverBought[i] = EMPTY_VALUE;  
                    OverSold[i] = EMPTY_VALUE;                 
                    Uptrend[i] = EMPTY_VALUE;                
                    Downtrend[i] = EMPTY_VALUE;                
                    SameDirection[i] = EMPTY_VALUE;    


                     //==ConsiderColorOverBoughtSold
                     if (ConsiderColorOverBoughtSold)
                         {
                         if (percentK > overBought)
                             {
                             OverBought[i] = 100;
                             }
                         else if (percentK < overSold)
                             {
                             OverSold[i] = 100;
                             }
                         else
                             {
                             if (percentK > percentK_previous)
                                 {
                                 Uptrend[i] = 100;    
                                 }
                             else if (percentK < percentK_previous)
                                 {
                                 Downtrend[i] = 100;    
                                 }
                             else if (percentK == percentK_previous)
                                 {
                                 SameDirection[i] = 100;    
                                 }                
                             }  
                         }
                    //==Only Direction Color
                    else
                         {
                         if (percentK > percentK_previous)
                             {
                             Uptrend[i] = 100;    
                             }
                         else if (percentK < percentK_previous)
                             {
                             Downtrend[i] = 100;    
                             }
                         else if (percentK == percentK_previous)
                             {
                             SameDirection[i] = 100;    
                             }  
                         }
                    } 
                 }
            // Different MTF Period: StochTimeFrame -> ChartTimeFrame                 
            else
                {
                for(i=0, y=0;i<limit-1;i++)
                    {
                    if (Time[i]<StochTimeArray[y]) y++;

                    percentK = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,y);
                    percentK_previous = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,y+1);

                    // DO ALERTS
                    if (alertsOn && i==0)
                        {
                        if (percentK>Alert1_CrossesAbove && percentK_previous<=Alert1_CrossesAbove) doAlert(" | Alert1_CrossesAbove " +Alert1_CrossesAbove);
                        if (percentK>Alert2_CrossesAbove && percentK_previous<=Alert2_CrossesAbove) doAlert(" Alert2_CrossesAbove " +Alert2_CrossesAbove);
                        
                        if (percentK<Alert1_CrossesBelow && percentK_previous>=Alert1_CrossesBelow) doAlert(" | Alert1_CrossesBelow " +Alert1_CrossesBelow);
                        if (percentK<Alert2_CrossesBelow && percentK_previous>=Alert2_CrossesBelow) doAlert(" | Alert2_CrossesBelow " +Alert2_CrossesBelow);
                        }
   
                    //  Now we just assign the colors
                    OverBought[i] = EMPTY_VALUE;  
                    OverSold[i] = EMPTY_VALUE;                 
                    Uptrend[i] = EMPTY_VALUE;                
                    Downtrend[i] = EMPTY_VALUE;                
                    SameDirection[i] = EMPTY_VALUE;    


                     //==ConsiderColorOverBoughtSold
                     if (ConsiderColorOverBoughtSold)
                         {
                         if (percentK > overBought)
                             {
                             OverBought[i] = 100;
                             }
                         else if (percentK < overSold)
                             {
                             OverSold[i] = 100;
                             }
                         else
                             {
                             if (percentK > percentK_previous)
                                 {
                                 Uptrend[i] = 100;    
                                 }
                             else if (percentK < percentK_previous)
                                 {
                                 Downtrend[i] = 100;    
                                 }
                             else if (percentK == percentK_previous)
                                 {
                                 SameDirection[i] = 100;    
                                 }                
                             }  
                         }
                    //==Only Direction Color
                    else
                         {
                         if (percentK > percentK_previous)
                             {
                             Uptrend[i] = 100;    
                             }
                         else if (percentK < percentK_previous)
                             {
                             Downtrend[i] = 100;    
                             }
                         else if (percentK == percentK_previous)
                             {
                             SameDirection[i] = 100;    
                             }  
                         }
                    }
                }      
            }
        }   


   return(0);
}
//+------------------------------------------------------------------+




void doStochasticCalculation(int STOCH_MODE, double& StochTimeFrame_TARGET_BUFFER[], double& TARGET_BUFFER[])
    {
    int  i, y,z;

    double StochTimeFrame_end,StochTimeFrame_start, StochEndStartDiff, StochDiff_PerChartBar, interpolation;     
    datetime interpol_time_end, interpol_time_start;
    int chartbar_shift_end, chartbar_shift_start,chartbar_shift_numBars; 
  
     
//=== UseInterpolation
    // MAKE ONLY SENSE IF: Different MTF Period: StochTimeFrame -> ChartTimeFrame  
    // ( we had that already checked before hand )
    if (UseInterpolation)
        {      
        for(i=0; i<Size_StochStochTimeArray;i++)
            {
            StochTimeFrame_TARGET_BUFFER[i] = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,STOCH_MODE,i);
            }  

         //================= do the interpolation
         
         
         // Size_StochStochTimeArray-1  because we need one in the past
         for(i=0; i<Size_StochStochTimeArray-1;i++) 
            {
            // if i==0 we have also to do the active candle
            if(i==0)
                {

                //We have to do two things The lastone and the active candle

                //==================== The last active Unfinished one (This includes also the parts till the new hour candle closes(total nearly two StochTimeFrameBars Time.
                StochTimeFrame_end  = StochTimeFrame_TARGET_BUFFER[0];
                StochTimeFrame_start  = StochTimeFrame_TARGET_BUFFER[1];
                interpol_time_end  = Time[0];
                interpol_time_start  = StochTimeArray[1];
                chartbar_shift_end = iBarShift(NULL,0,interpol_time_end);
                chartbar_shift_start = iBarShift(NULL,0,interpol_time_start);
                chartbar_shift_numBars=chartbar_shift_start-chartbar_shift_end; 
                StochEndStartDiff=MathAbs(StochTimeFrame_end-StochTimeFrame_start);

                // CHECK ZERO division
               if (chartbar_shift_numBars <= 0)
                    {
                    continue;
                    }
               else
                    {
                    StochDiff_PerChartBar=StochEndStartDiff/chartbar_shift_numBars;
                    }                

                for (z=chartbar_shift_numBars; z>=0; z--)
                    {     
                    // end bar
                    if (z==chartbar_shift_numBars)
                        {
                        interpolation=StochTimeFrame_end;
                        TARGET_BUFFER[chartbar_shift_end] = interpolation;
                        }
                    // start bar
                    else if (z==0)
                        {
                        interpolation=StochTimeFrame_start;               
                        TARGET_BUFFER[chartbar_shift_start] = interpolation;                     
                        }
                    // Intermedia bars
                    else
                       {                                                  
                        if (StochTimeFrame_end > StochTimeFrame_start) 
                           {
                           //UP
                           interpolation=interpolation-StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_end < StochTimeFrame_start) 
                           {
                           //DOWN
                            interpolation=interpolation+StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_end == StochTimeFrame_start) 
                           {
                           //SAME
                           interpolation=interpolation;
                           }
                        TARGET_BUFFER[chartbar_shift_start-z] = interpolation;                           
                        }
                     }
                }
            // i = greater than 0: normal past data)
            else
                {
                StochTimeFrame_end  = StochTimeFrame_TARGET_BUFFER[i];
                StochTimeFrame_start  = StochTimeFrame_TARGET_BUFFER[i+1];
                            
                interpol_time_end  = StochTimeArray[i];
                interpol_time_start  = StochTimeArray[i+1];
                chartbar_shift_end = iBarShift(NULL,0,interpol_time_end);
                chartbar_shift_start = iBarShift(NULL,0,interpol_time_start);
                chartbar_shift_numBars=chartbar_shift_start-chartbar_shift_end; 

                StochEndStartDiff=MathAbs(StochTimeFrame_TARGET_BUFFER[i]-StochTimeFrame_TARGET_BUFFER[i+1]);
                // CHECK ZERO division
               if (chartbar_shift_numBars <= 0)
                    {
                    continue;
                    }
               else
                    {
                    StochDiff_PerChartBar=StochEndStartDiff/chartbar_shift_numBars;
                    }                

                for (z=chartbar_shift_numBars; z>=0; z--)
                    {     
                    // end bar
                    if (z==chartbar_shift_numBars)
                       {
                       interpolation=StochTimeFrame_end;
                       TARGET_BUFFER[chartbar_shift_end] = interpolation;
                       }
                    // start bar
                    else if (z==0)
                       {
                       interpolation=StochTimeFrame_start;
                       TARGET_BUFFER[chartbar_shift_start] = interpolation;
                       }
                    // Intermedia bars
                    else
                       {                                                  
                        if (StochTimeFrame_end > StochTimeFrame_start) 
                           {
                           //UP
                           interpolation=interpolation-StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_end < StochTimeFrame_start) 
                           {
                           //DOWN
                            interpolation=interpolation+StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_end == StochTimeFrame_start) 
                           {
                           //SAME
                           interpolation=interpolation;
                           }
                           
                        TARGET_BUFFER[chartbar_shift_start-z] = interpolation;
                        }
                     }
                }                
            }   
        }
//=== NO Interpolation        
     else
        {
       
        // Same Period: StochTimeFrame -> ChartTimeFrame
        if (StochTimeFrame == Period())
            {
            for(i=0;i<limit-1;i++)
                {                   
                TARGET_BUFFER[i] = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,STOCH_MODE,i);
                }
             } 
        // Different MTF Period: StochTimeFrame -> ChartTimeFrame                
        else
            {
            for(i=0, y=0;i<limit-1;i++)
                {
                if (Time[i]<StochTimeArray[y]) y++;                   
                    TARGET_BUFFER[i] = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,STOCH_MODE,y);
                } 
            }
       }
       
}
//+------------------------------------------------------------------+

void doAlert(string doWhat)
    {
    static string   previousAlert="nothing";
    static datetime previousTime;
    string message;
   
    if (previousAlert != doWhat || previousTime != Time[0]) 
        {
        previousAlert  = doWhat;
        previousTime   = Time[0];
            
        message =  StringConcatenate(UniquePrefix," (",KPeriod,",",DPeriod,",",Slowing,")"," " ,TimeFrameToString(StochTimeFrame), ": ",Symbol(),doWhat);
        if (alertsMessage) Alert(message);
        if (alertsSound)   PlaySound(SoundFileName);
        SendMail(StringConcatenate("UStochastic Alert ",Symbol()),message);
        }        
}
//+------------------------------------------------------------------+


string alertsOnDescription(bool _alertsOn)
{
   string answer;
   switch(_alertsOn)
   {
      case 0:  answer = "OFF"    ; break; 
      case 1:  answer = "ON" ; break;
      default: answer = UniquePrefix + ": Invalid AlertsOn requested"; Alert(answer); PlaySound("alert.wav");
   }
   return(answer);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

string priceDescription(int mode)
{
   string answer;
   switch(mode)
   {
      case 0:  answer = "Low/High"    ; break; 
      case 1:  answer = "Close/Close" ; break;
      default: answer = UniquePrefix + ": Invalid price field requested"; Alert(answer); PlaySound("alert.wav");
   }
   return(answer);
}
//+------------------------------------------------------------------+
string maDescription(int mode)
{
   string answer;
   switch(mode)
   {
      case MODE_SMA:  answer = "SMA"  ; break; 
      case MODE_EMA:  answer = "EMA"  ; break;
      case MODE_SMMA: answer = "SMMA" ; break;
      case MODE_LWMA: answer = "LWMA" ; break;
      default:        answer = UniquePrefix + ": Invalid MA mode requested"; Alert(answer); PlaySound("alert.wav");
   }
   return(answer);
}
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
    {
    string tfs;
    switch(tf) {
        case 0:  tfs="Current TF"  ; break;
        case PERIOD_M1:  tfs="M1"  ; break;
        case PERIOD_M5:  tfs="M5"  ; break;
        case PERIOD_M15: tfs="M15" ; break;
        case PERIOD_M30: tfs="M30" ; break;
        case PERIOD_H1:  tfs="H1"  ; break;
        case PERIOD_H4:  tfs="H4"  ; break;
        case PERIOD_D1:  tfs="D1"  ; break;
        case PERIOD_W1:  tfs="W1"  ; break;
        case PERIOD_MN1: tfs="MN1";
        default: tfs = UniquePrefix + ": Invalid TimeFrame requested"; Alert(tfs); PlaySound("alert.wav");
   }
   return(tfs);
}
//+------------------------------------------------------------------+


