//+------------------------------------------------------------------+
//|                                       Color Stochastic v1.02.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
//|                                         #MTF Stochastic v2.0.mq4 |
//|										 2007, Christof Risch (iya)	 |
//|                                                                  |
//| 2011 MJ   used also some ideas from the two mentioned above      |
//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers   7
#property  indicator_minimum 0
#property  indicator_maximum 100
#property indicator_color1 LightSlateGray //Stochastick K%
#property indicator_color2 Red //Overbought
#property indicator_color3 Blue //Oversold 
#property indicator_color4 Orange //Uptrend
#property indicator_color5 DeepSkyBlue //Downtrend
#property indicator_color6 LightSlateGray  // SameDirection - if ShowOnlyDirection=false ( in Overbought and Oversold area SameDirection color disregarded)
#property indicator_color7 CLR_NONE //only calculation
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3
#property indicator_width7 0


//--- Prefix for objects so we can delete them later 
extern   string _Info="== set a unique prefix for objects ==";
extern string UniquePrefix="UniversalStochastic_MainK_mj";

//---- parameters
extern string ______________0____________ = "==Stochastic settings==";
extern string note1 = "Chart Time Frame";
extern string note2 = "0=current time frame";
extern string note3 = "1=M1, 5=M5, 15=M15, 30=M30";
extern string note4 = "60=H1, 240=H4, 1440=D1";
extern string note5 = "10080=W1, 43200=MN1";
extern int	StochTimeFrame	= 5;		// {1=M1, 5=M5, 15=M15, ..., 1440=D1, 10080=W1, 43200=MN1}
extern string note6 = "Stochastic settings";
extern string    Attention_DPeriod   = "NOT USED: DPeriod is set to 1";          // DPerid is not taken into account
extern int       KPeriod  =  3;
extern int       Slowing     =  2;
extern string note7 = "0=sma, 1=ema, 2=smma, 3=lwma";
extern int       MAMethod    =   0;
extern string note8 = "0=high/low, 1=close/close";
extern int       PriceField  =   0;
extern string note9 = "overbought level";
extern int       overBought  =  80;
extern string note10 = "oversold level";
extern int       overSold    =  20;
extern string ______________1____________ = "==Stochastic Options==";
extern bool ShowBars=true;
extern bool ConsiderColorOverBoughtSold=true;
extern string note11 = "For Line Or Bar: Interpolation";
extern string note12 = "Note: ifUseInterpolation=true";
extern string note13 = "PastData are always ReAdjusted";
extern bool UseInterpolation=false;

extern string note14 = "==ReAdjustDataForPastBars==";
extern string note15 = "works on Bars and Line display";
extern bool ReAdjustDataForPastBars=true;

extern bool DontDisplayValuesAndSettings=false;



//---- buffers
double   KFull[];
double SameDirection[];
double Uptrend[];
double Downtrend[];
double OverBought[];
double OverSold[];
double   tempKFull[];

double   StochTimeFrame_KFull[];
datetime StochTimeArray[];
int Size_StochStochTimeArray;


int ChartBarsPerStochTimeFrame;
double percentK;
double percentK_previous;
string	IndicatorName;
int  DPeriod     =  1;          // DPerid is not taken into account


   
bool alertflag=0;
string _errorStr="NONE";
string _infoStr;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  	switch(StochTimeFrame)
	{
		case 1:		IndicatorName="Period M1";	break;
		case 5:		IndicatorName="Period M5"; break;
		case 15:		IndicatorName="Period M15"; break;
		case 30:		IndicatorName="Period M30"; break;
		case 60:		IndicatorName="Period H1"; break;
		case 240:	IndicatorName="Period H4"; break;
		case 1440:	IndicatorName="Period D1"; break;
		case 10080:	IndicatorName="Period W1"; break;
		case 43200:	IndicatorName="Period MN1"; break;
		default:	  {StochTimeFrame = Period(); init(); return(0);}
	}

  
    if (DontDisplayValuesAndSettings)
        {
        IndicatorShortName(" "); 
	   }
	else
	   {
	   IndicatorName = IndicatorName+" "+UniquePrefix+"("+KPeriod+","+DPeriod+","+Slowing+")";
	   IndicatorShortName(IndicatorName); 
	   }

 
    // Check StochTimeFrame setting not smaller than current 
    if(StochTimeFrame < Period() && StochTimeFrame != 0)
        {
        _errorStr=UniquePrefix+": ERROR \"StochTimeFrame\" is less than Chart Period.";
        if(alertflag == 0) {Alert(_errorStr); PlaySound("alert.wav"); alertflag = 1;}
        return;
        }
         
// Check StochTimeFrame one of the possible for MT4          
    if (!(StochTimeFrame == 0 || StochTimeFrame == 1 || StochTimeFrame == 5 || StochTimeFrame == 15 || StochTimeFrame == 30 || StochTimeFrame == 60 || StochTimeFrame == 240 || StochTimeFrame == 1440 || StochTimeFrame == 10080 || StochTimeFrame == 43200))
        {
        _errorStr=UniquePrefix+": ERROR \"StochTimeFrame\" : < " +StochTimeFrame+ " > is not one of the possible MT4 TimeFrames.";
        if(alertflag == 0) {Alert(_errorStr); PlaySound("alert.wav"); alertflag = 1;}
        return;
        }
 
// UseInterpolation MAKE ONLY SENSE IF: Different MTF Period: StochTimeFrame -> ChartTimeFrame 
    if (UseInterpolation && StochTimeFrame == 0)
        {
        _errorStr=UniquePrefix+": ERROR \"StochTimeFrame\": "+StochTimeFrame+" < UseInterpolation  > MAKES ONLY SENSE IF: StochTimeFrame -> ChartTimeFrame use different periods.";
        if(alertflag == 0) {Alert(_errorStr); PlaySound("alert.wav"); alertflag = 1;}
        return;
        }
 
// UseInterpolation MAKE ONLY SENSE IF: Different MTF Period: StochTimeFrame -> ChartTimeFrame 
    if (UseInterpolation && StochTimeFrame != 0 && StochTimeFrame==Period())
        {
        _infoStr=UniquePrefix+": ERROR \"StochTimeFrame\": "+StochTimeFrame+" < UseInterpolation  > MAKES ONLY SENSE IF: StochTimeFrame -> ChartTimeFrame use different periods.";
        if(alertflag == 0) {Alert(_infoStr); PlaySound("alert.wav"); alertflag = 1;}
        IndicatorShortName("ATTENTION: <UseInterpolation> makes NO SENSE ON same CHART TF");
        SetIndexLabel(0,"");
        }
        

 

    if (ShowBars)
        {
        SetIndexStyle(0,DRAW_NONE);
        SetIndexBuffer(0,KFull);
        if (DontDisplayValuesAndSettings) SetIndexLabel(0,"");
             
        SetIndexStyle(1,DRAW_HISTOGRAM);
        SetIndexBuffer(1,OverBought);
        if (DontDisplayValuesAndSettings) SetIndexLabel(1,""); 
         
        SetIndexStyle(2,DRAW_HISTOGRAM);
        SetIndexBuffer(2,OverSold);
        if (DontDisplayValuesAndSettings) SetIndexLabel(2,"");  

        SetIndexStyle(3,DRAW_HISTOGRAM);
        SetIndexBuffer(3,Uptrend);
        if (DontDisplayValuesAndSettings) SetIndexLabel(3,"");

        SetIndexStyle(4,DRAW_HISTOGRAM);
        SetIndexBuffer(4,Downtrend);
        if (DontDisplayValuesAndSettings) SetIndexLabel(4,"");

        SetIndexStyle(5,DRAW_HISTOGRAM);
        SetIndexBuffer(5,SameDirection);
        if (DontDisplayValuesAndSettings) SetIndexLabel(5,"");

        }
    // normal Line Display
    else
        {
        SetIndexStyle(0,DRAW_LINE);
        SetIndexBuffer(0,KFull);
        if (DontDisplayValuesAndSettings) SetIndexLabel(0,"");
             
        SetIndexStyle(1,DRAW_NONE);
        SetIndexBuffer(1,OverBought);
        if (DontDisplayValuesAndSettings) SetIndexLabel(1,""); 
         
        SetIndexStyle(2,DRAW_NONE);
        SetIndexBuffer(2,OverSold);
        if (DontDisplayValuesAndSettings) SetIndexLabel(2,"");  

        SetIndexStyle(3,DRAW_NONE);
        SetIndexBuffer(3,Uptrend);
        if (DontDisplayValuesAndSettings) SetIndexLabel(3,"");

        SetIndexStyle(4,DRAW_NONE);
        SetIndexBuffer(4,Downtrend);
        if (DontDisplayValuesAndSettings) SetIndexLabel(4,"");

        SetIndexStyle(5,DRAW_NONE);
        SetIndexBuffer(5,SameDirection);
        if (DontDisplayValuesAndSettings) SetIndexLabel(5,"");
        }
        
        // ONLY CALCULATION
        SetIndexStyle(6,DRAW_NONE);
        SetIndexBuffer(6,tempKFull);
        SetIndexLabel(6,"");


    IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
 

    //===========================
    ChartBarsPerStochTimeFrame=StochTimeFrame/Period();
//----
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    if (_errorStr!="NONE")
        {  
        IndicatorShortName("ERROR ERROR");   
        if(alertflag == 0) {Alert(_errorStr); alertflag = 1;}
        return;
        }
        

    int counted_bars=IndicatorCounted();
    //---- check for possible errors
    if(counted_bars<0) return(-1);
    //---- the last counted bar will be recounted
    if(counted_bars>0) counted_bars--;
    //int limit=Bars-counted_bars+StochTimeFrame/Period();
    int limit;
    
    if (ReAdjustDataForPastBars)
        {
        limit = Bars-counted_bars+StochTimeFrame/Period();
        }
    else
        {
        limit = Bars-counted_bars;
        } 

   		     
   //-----------------------------------------------------------------------

   
    ArrayCopySeries(StochTimeArray,MODE_TIME,Symbol(),StochTimeFrame);
    Size_StochStochTimeArray = ArraySize(StochTimeArray);   
    ArrayResize(StochTimeFrame_KFull,Size_StochStochTimeArray);

    int  i,  y,z;

    double StochTimeFrame_KFull_end,StochTimeFrame_KFull_start, StochEndStartDiff, StochDiff_PerChartBar, interpolation_kFull;          
    datetime interpol_time_end, interpol_time_start;
    int chartbar_shift_end, chartbar_shift_start,chartbar_shift_numBars; 


//=== UseInterpolation


    // MAKE ONLY SENSE IF: Different MTF Period: StochTimeFrame -> ChartTimeFrame  
    // ( we had that already checked before hand )
    if (UseInterpolation)
        {
        // normal Line Display  (need it also for BarDisplay)       
        for(i=0; i<Size_StochStochTimeArray;i++)
            {
            StochTimeFrame_KFull[i] = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i);
            }  
                         
         //================= do the interpolation
         
         // Size_StochStochTimeArray-1  because we need one in the past
         for(i=0; i<Size_StochStochTimeArray-1;i++) 
            {
            // if i==0 we have also to do the active candle
            if(i==0)
                {

                //We have to do two things The lastone and the active candle

//==================== The last active Unfinished one (This includes also the parts till the new hour candle closes(total nearly two StochTimeFrameBars Time.
                StochTimeFrame_KFull_end  = StochTimeFrame_KFull[0];
                StochTimeFrame_KFull_start  = StochTimeFrame_KFull[1];
                interpol_time_end  = Time[0];
                interpol_time_start  = StochTimeArray[1];
                chartbar_shift_end = iBarShift(NULL,0,interpol_time_end);
                chartbar_shift_start = iBarShift(NULL,0,interpol_time_start);
                chartbar_shift_numBars=chartbar_shift_start-chartbar_shift_end; 
                StochEndStartDiff=MathAbs(StochTimeFrame_KFull_end-StochTimeFrame_KFull_start);
                    
                // CHECK ZERO division
               if (chartbar_shift_numBars <= 0)
                    {
                    continue;
                    }
               else
                    {
                    StochDiff_PerChartBar=StochEndStartDiff/chartbar_shift_numBars;
                    }                

                for (z=chartbar_shift_numBars; z>=0; z--)
                    {     
                    // end bar
                    if (z==chartbar_shift_numBars)
                       {
                       interpolation_kFull=StochTimeFrame_KFull_end;
                       tempKFull[chartbar_shift_end] = interpolation_kFull;
                        KFull[chartbar_shift_end] = interpolation_kFull;   // asign it straight away don't need to go through the loop again
                       }
                    // start bar
                    else if (z==0)
                       {
                        interpolation_kFull=StochTimeFrame_KFull_start;
                        tempKFull[chartbar_shift_start] = interpolation_kFull; 
                        KFull[chartbar_shift_start] = interpolation_kFull;   // asign it straight away don't need to go through the loop again                       
                       }
                    // Intermedia bars
                    else
                       {                                                  
                        if (StochTimeFrame_KFull_end > StochTimeFrame_KFull_start) 
                           {
                           //UP
                           interpolation_kFull=interpolation_kFull-StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_KFull_end < StochTimeFrame_KFull_start) 
                           {
                           //DOWN
                            interpolation_kFull=interpolation_kFull+StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_KFull_end == StochTimeFrame_KFull_start) 
                           {
                           //SAME
                           interpolation_kFull=interpolation_kFull;
                           }
                           
                        tempKFull[chartbar_shift_start-z] = interpolation_kFull;
                        KFull[chartbar_shift_start-z] = interpolation_kFull;   // asign it straight away don't need to go through the loop again                              
                        }
                     }
                }
            // i = greater than 0: normal past data)
            else
                {
                StochTimeFrame_KFull_end  = StochTimeFrame_KFull[i];
                StochTimeFrame_KFull_start  = StochTimeFrame_KFull[i+1];
                            
                interpol_time_end  = StochTimeArray[i];
                interpol_time_start  = StochTimeArray[i+1];
                chartbar_shift_end = iBarShift(NULL,0,interpol_time_end);
                chartbar_shift_start = iBarShift(NULL,0,interpol_time_start);
                chartbar_shift_numBars=chartbar_shift_start-chartbar_shift_end; 

                StochEndStartDiff=MathAbs(StochTimeFrame_KFull[i]-StochTimeFrame_KFull[i+1]);
                // CHECK ZERO division
               if (chartbar_shift_numBars <= 0)
                    {
                    continue;
                    }
               else
                    {
                    StochDiff_PerChartBar=StochEndStartDiff/chartbar_shift_numBars;
                    }                

                for (z=chartbar_shift_numBars; z>=0; z--)
                    {     
                    // end bar
                    if (z==chartbar_shift_numBars)
                       {
                       interpolation_kFull=StochTimeFrame_KFull_end;
                       tempKFull[chartbar_shift_end] = interpolation_kFull;
                       KFull[chartbar_shift_end] = interpolation_kFull;   // asign it straight away don't need to go through the loop again
                       }
                    // start bar
                    else if (z==0)
                       {
                       interpolation_kFull=StochTimeFrame_KFull_start;
                       tempKFull[chartbar_shift_start] = interpolation_kFull;
                       KFull[chartbar_shift_start] = interpolation_kFull; // asign it straight away don't need to go through the loop again
                       }
                    // Intermedia bars
                    else
                       {                                                  
                        if (StochTimeFrame_KFull_end > StochTimeFrame_KFull_start) 
                           {
                           //UP
                           interpolation_kFull=interpolation_kFull-StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_KFull_end < StochTimeFrame_KFull_start) 
                           {
                           //DOWN
                            interpolation_kFull=interpolation_kFull+StochDiff_PerChartBar;
                           }
                        else if (StochTimeFrame_KFull_end == StochTimeFrame_KFull_start) 
                           {
                           //SAME
                           interpolation_kFull=interpolation_kFull;
                           }
                           
                        tempKFull[chartbar_shift_start-z] = interpolation_kFull;
                        KFull[chartbar_shift_start-z] = interpolation_kFull; // asign it straight away don't need to go through the loop again
                        }
                     }
                }                
            }   
               
         //ShowBars With Interpolation
        if (ShowBars)
            {  
            for(i=0;i<limit-1;i++)
                {
                percentK = tempKFull[i];
                percentK_previous = tempKFull[i+1];

                OverBought[i] = EMPTY_VALUE;  
                OverSold[i] = EMPTY_VALUE;                 
                Uptrend[i] = EMPTY_VALUE;                
                Downtrend[i] = EMPTY_VALUE;                
                SameDirection[i] = EMPTY_VALUE;    


                 //==ConsiderColorOverBoughtSold
                 if (ConsiderColorOverBoughtSold)
                     {
                     if (percentK > overBought)
                         {
                         OverBought[i] = 100;
                         }
                     else if (percentK < overSold)
                         {
                         OverSold[i] = 100;
                         }
                     else
                         {
                         if (percentK > percentK_previous)
                             {
                             Uptrend[i] = 100;    
                             }
                         else if (percentK < percentK_previous)
                             {
                             Downtrend[i] = 100;    
                             }
                         else if (percentK == percentK_previous)
                             {
                             SameDirection[i] = 100;    
                             }                
                         }  
                     }
                //==Only Direction Color
                else
                     {
                     if (percentK > percentK_previous)
                         {
                         Uptrend[i] = 100;    
                         }
                     else if (percentK < percentK_previous)
                         {
                         Downtrend[i] = 100;    
                         }
                     else if (percentK == percentK_previous)
                         {
                         SameDirection[i] = 100;    
                         }  
                     }                
                } 
            }
        }

//=== NO Interpolation        
     else
        {
        // ShowBars No Interpolation
        if (ShowBars)
            {
            // Same Period: StochTimeFrame -> ChartTimeFrame
            if (StochTimeFrame == Period())
                {
                for(i=0;i<limit-1;i++)
                    {
                    percentK = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i);
                    percentK_previous = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i+1);
        
                     SameDirection[i] = EMPTY_VALUE;  
                     Uptrend[i] = EMPTY_VALUE;                 
                     Downtrend[i] = EMPTY_VALUE;                
                     OverBought[i] = EMPTY_VALUE;                
                     OverSold[i] = EMPTY_VALUE;       

                     //==ConsiderColorOverBoughtSold
                     if (ConsiderColorOverBoughtSold)
                         {
                         if (percentK > overBought)
                             {
                             OverBought[i] = 100;
                             }
                         else if (percentK < overSold)
                             {
                             OverSold[i] = 100;
                             }
                         else
                             {
                             if (percentK > percentK_previous)
                                 {
                                 Uptrend[i] = 100;    
                                 }
                             else if (percentK < percentK_previous)
                                 {
                                 Downtrend[i] = 100;    
                                 }
                             else if (percentK == percentK_previous)
                                 {
                                 SameDirection[i] = 100;    
                                 }                
                             }  
                         }
                    //==Only Direction Color
                     else
                         {
                         if (percentK > percentK_previous)
                             {
                             Uptrend[i] = 100;    
                             }
                         else if (percentK < percentK_previous)
                             {
                             Downtrend[i] = 100;    
                             }
                         else if (percentK == percentK_previous)
                             {
                             SameDirection[i] = 100;    
                             }  
                         }
                    } 
                 }
        
            // Different MTF Period: StochTimeFrame -> ChartTimeFrame                 
            else
                {
                for(i=0, y=0;i<limit-1;i++)
                    {
                    if (Time[i]<StochTimeArray[y]) y++;

                    percentK = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,y);
                    percentK_previous = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,y+1);
        
                     SameDirection[i] = EMPTY_VALUE;  
                     Uptrend[i] = EMPTY_VALUE;                 
                     Downtrend[i] = EMPTY_VALUE;                
                     OverBought[i] = EMPTY_VALUE;                
                     OverSold[i] = EMPTY_VALUE;       


                     //==ConsiderColorOverBoughtSold
                     if (ConsiderColorOverBoughtSold)
                         {
                         if (percentK > overBought)
                             {
                             OverBought[i] = 100;
                             }
                         else if (percentK < overSold)
                             {
                             OverSold[i] = 100;
                             }
                         else
                             {
                             if (percentK > percentK_previous)
                                 {
                                 Uptrend[i] = 100;    
                                 }
                             else if (percentK < percentK_previous)
                                 {
                                 Downtrend[i] = 100;    
                                 }
                             else if (percentK == percentK_previous)
                                 {
                                 SameDirection[i] = 100;    
                                 }                
                             }  
                         }
                    //==Only Direction Color
                     else
                         {
                         if (percentK > percentK_previous)
                             {
                             Uptrend[i] = 100;    
                             }
                         else if (percentK < percentK_previous)
                             {
                             Downtrend[i] = 100;    
                             }
                         else if (percentK == percentK_previous)
                             {
                             SameDirection[i] = 100;    
                             }  
                         }
                    }
                }      
        }   
        // normal Line Display   No Interpolation
        else
            {
            // Same Period: StochTimeFrame -> ChartTimeFrame
            if (StochTimeFrame == Period())
                {
                //Calculate KFull
                for(i=0;i<limit-1;i++)
                    {                   
                    KFull[i] = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i);
                    }
                 } 
            // Different MTF Period: StochTimeFrame -> ChartTimeFrame                
            else
                {
                //Calculate KFull
                for(i=0, y=0;i<limit-1;i++)
                    {
                    if (Time[i]<StochTimeArray[y]) y++;                   
                        KFull[i] = iStochastic(NULL,StochTimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,y);
                    } 
                }
           }
    }


   return(0);

}


