//+------------------------------------------------------------------+
//|                                             Stoch_Divergence.mq4 |
//|                                                        SouthAlex |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "SouthAlex"
#property link      ""

#property indicator_separate_window
//#property indicator_minimum -100
//#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
//---- input parameters
extern string    Slave_Symbol="EURUSD";
extern int       K_Period=5;
extern int       D_Period=3;
extern int       Slowing=3;
extern int       Method=0; //0-SMA, 1-EMA, 2-SMMA, 3- LWMA
extern int       Price_Type=1; // 0-Low/High, 1-Close/Close


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
   
   Slave_Symbol=StringTrimLeft(StringTrimRight(Slave_Symbol));
   if(Slave_Symbol=="")Slave_Symbol=Symbol();
   

//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

   datetime daytimes[];
   static bool err;
   ArrayCopySeries(daytimes,MODE_TIME,Slave_Symbol,0);
      if(GetLastError()==4066){
         Comment("   "+Slave_Symbol);
         err=true;
         return(0);
      }
   int limit=Bars-IndicatorCounted();
      if(err){
         err=false;
         limit=Bars;
         Comment("");
      }

   double this.D,
	this.K,
	slave.D,
	slave.K;
   RefreshRates();

     for(int i=0; i<limit; i++){
        int ii=iBarShift(Slave_Symbol,0,Time[i],false);
        this.D=iStochastic(NULL,0,K_Period,D_Period,Slowing,Method,Price_Type,MODE_MAIN,i);
        this.K=iStochastic(NULL,0,D_Period,D_Period,Slowing,Method,Price_Type,MODE_SIGNAL,i);
        slave.D=iStochastic(Slave_Symbol,Period(),K_Period,D_Period,Slowing,Method,Price_Type,MODE_MAIN,ii);
        slave.K=iStochastic(Slave_Symbol,Period(),D_Period,D_Period,Slowing,Method,Price_Type,MODE_SIGNAL,ii);
        ExtMapBuffer1[i]=this.D-slave.D;
        ExtMapBuffer2[i]=this.K-slave.K;
    }

//----
   return(0);
  }
//+------------------------------------------------------------------+