//+------------------------------------------------------------------+
//|                                                    Avg_Stoch.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red

extern int K_Length=5;
extern int Slowing=3;
extern int D_Length=3;
extern int Method=0;      // 0 - SMA
                          // 1 - EMA
                          // 2 - SMMA
                          // 3 - LWMA
                          
extern int Price_Field=0; // 0 - Low/High
                          // 1 - Close/Close
extern int Avg_Length=4;

double K[], D[];
double Stoch_K[], Stoch_D[];

int init()
{
 IndicatorShortName("Averaged stochastic oscillator");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(0,K);
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(1,D);
 SetIndexStyle(2,DRAW_NONE);
 SetIndexBuffer(2,Stoch_K);
 SetIndexStyle(3,DRAW_NONE);
 SetIndexBuffer(3,Stoch_D);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 pos=limit;
 while(pos>=0)
 {
  Stoch_K[pos]=iStochastic(NULL, 0, K_Length, D_Length, Slowing, Method, Price_Field, MODE_MAIN, pos);
  Stoch_D[pos]=iStochastic(NULL, 0, K_Length, D_Length, Slowing, Method, Price_Field, MODE_SIGNAL, pos);
  pos--;
 } 
 
 int i;
 double Sum_K, Sum_D;
 pos=limit;
 while(pos>=0)
 {
  Sum_K=0.;
  Sum_D=0.;
  for (i=0;i<Avg_Length;i++)
  {
   Sum_K=Sum_K+Stoch_K[pos+i];
   Sum_D=Sum_D+Stoch_D[pos+i];
  }
  K[pos]=Sum_K/Avg_Length;
  D[pos]=Sum_D/Avg_Length;
  pos--;
 }  
 
 return(0);
}

