//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers    7
#property indicator_color1     Green
#property indicator_color2     Orange
#property indicator_color3     Gray
#property indicator_color4     Gray
#property indicator_color5     Green
#property indicator_color6     Orange
#property indicator_color7     Orange
#property indicator_width5     2
#property indicator_width6     2
#property indicator_width7     2
#property indicator_style1     STYLE_DOT
#property indicator_style2     STYLE_DOT
#property indicator_style3     STYLE_DOT
#property indicator_style4     STYLE_DOT

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    StochasticPeriod   = 55;
extern int    EmaSmoothingPeriod = 15;
extern int    ChannelPeriod      = 15;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsNotify       = false;
extern bool   alertsEmail        = false;
extern string soundFile          = "alert2.wav";
extern double UpLevel            = 80;
extern double DownLevel          = 20;

//
//
//
//
//

double sto[];
double stot[];
double stoDa[];
double stoDb[];
double chanup[];
double chandn[];
double levup[];
double levdn[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,chanup); 
   SetIndexBuffer(1,chandn); 
   SetIndexBuffer(2,levup); 
   SetIndexBuffer(3,levdn); 
   SetIndexBuffer(4,sto);
   SetIndexBuffer(5,stoDa);
   SetIndexBuffer(6,stoDb);
   SetIndexBuffer(7,slope);
   SetIndexBuffer(8,stot);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //

      IndicatorShortName(timeFrameToString(timeFrame)+" Double smoothed stochastic - slope ("+StochasticPeriod+","+EmaSmoothingPeriod+")");
return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(0);
      if (counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { chanup[0] = MathMin(limit+1,Bars-1); return(0); }
 
   //
   //
   //
   //
   //
 
   if (calculateValue || timeFrame == Period())
   {
      if (slope[limit]==-1) CleanPoint(limit,stoDa,stoDb);
      for(int i=limit; i>=0; i--)
      {
         stoDa[i] = EMPTY_VALUE;
         stoDb[i] = EMPTY_VALUE;
         stot[i]  = iDss(StochasticPeriod,EmaSmoothingPeriod,i);
         slope[i] = slope[i+1];
         chanup[i] = High[ArrayMaximum(High,ChannelPeriod,i)];
         chandn[i] = Low [ArrayMinimum(Low ,ChannelPeriod,i)];
         double range = chanup[i]-chandn[i];
            if (stot[i]>stot[i+1]) slope[i] =  1;
            if (stot[i]<stot[i+1]) slope[i] = -1;
            sto[i]   = range*stot[i]  /100+chandn[i];
            levup[i] = range*UpLevel  /100+chandn[i];
            levdn[i] = range*DownLevel/100+chandn[i];
               if (slope[i] == -1) PlotPoint(i,stoDa,stoDb,sto);
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;    
        if (slope[whichBar] != slope[whichBar+1])
        if (slope[whichBar] == 1)
              doAlert("Sloping up");
        else  doAlert("Sloping down");       
      }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,stoDa,stoDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         chanup[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochasticPeriod,EmaSmoothingPeriod,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
         chandn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochasticPeriod,EmaSmoothingPeriod,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
         levup[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochasticPeriod,EmaSmoothingPeriod,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
         levdn[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochasticPeriod,EmaSmoothingPeriod,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         sto[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochasticPeriod,EmaSmoothingPeriod,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
         slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StochasticPeriod,EmaSmoothingPeriod,ChannelPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,7,y);
         stoDa[i]   = EMPTY_VALUE;
         stoDb[i]   = EMPTY_VALUE;
   }
   for (i=limit; i>=0; i--)if (slope[i] == -1) PlotPoint(i,stoDa,stoDb,sto);
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDss[][2];
double iDss(int tStochasticPeriod, int EMAPeriod, int i, int instanceNo=0)
{
   if (ArrayRange(workDss,0) != Bars) ArrayResize(workDss,Bars); int r=Bars-i-1; instanceNo*=2;

   //
   //
   //
   //
   //

      double alpha = 2.0/(1.0+EMAPeriod);
      double tsto  = 0;
      double max   = High[i]; 
      double min   = Low[i];
         for(int k=1; k<tStochasticPeriod; k++)
         {
            max = MathMax(max,High[i+k]);
            min = MathMin(min,Low [i+k]);
         }            
         if (max!=min) tsto = (Close[i]-min)/(max-min)*100.00;

         workDss[r][instanceNo] = workDss[r-1][instanceNo]+alpha*(tsto-workDss[r-1][instanceNo]);
      
         //
         //
         //
         //
         //
      
         tsto = 0;
         max = workDss[r][instanceNo]; 
         min = workDss[r][instanceNo];
            for(k=1; k<tStochasticPeriod; k++)
            {
               max = MathMax(max,workDss[r-k][instanceNo]);
               min = MathMin(min,workDss[r-k][instanceNo]);
            }
            if (max!=min) tsto = (workDss[r][instanceNo]-min)/(max-min)*100.00;

         workDss[r][instanceNo+1] = workDss[r-1][instanceNo+1]+alpha*(tsto-workDss[r-1][instanceNo+1]);

         //
         //
         //
         //
         //
         
   return(workDss[r][instanceNo+1]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Double smoothed stochastic - slope ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Double smoothed stochastic - slope "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}   
