//+------------------------------------------------------------------+
//|                                   Double Smoothed Stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int StochasticPeriod = 55;
extern int EMAPeriod        = 15;

//
//
//
//
//

double histoup[];
double histodn[];
double upBuffera[];
double wrBuffera[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, histoup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, histodn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, upBuffera);
   SetIndexBuffer(3, wrBuffera);
   
   IndicatorShortName("Double smoothed stochastic "+StochasticPeriod+","+EMAPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //

      double alpha = 2.0/(1.0+EMAPeriod);
      for(int i = limit; i >= 0 ; i--)
      {
         double max = High[ArrayMaximum(High,StochasticPeriod,i)];
         double min =  Low[ArrayMinimum( Low,StochasticPeriod,i)];
         if (max!=min)
               double sto = (Close[i]-min)/(max-min)*100.00;
         else         sto = 0;            
         wrBuffera[i] = wrBuffera[i+1]+alpha*(sto-wrBuffera[i+1]);
      
         //
         //
         //
         //
         //
      
         max = wrBuffera[ArrayMaximum(wrBuffera,StochasticPeriod,i)];
         min = wrBuffera[ArrayMinimum(wrBuffera,StochasticPeriod,i)];
         if (max!=min)
               sto = (wrBuffera[i]-min)/(max-min)*100.00;
         else  sto = 0;            
         upBuffera[i] = upBuffera[i+1]+alpha*(sto-upBuffera[i+1]);
         histoup[i]   = EMPTY_VALUE;
         histodn[i]   = EMPTY_VALUE;
            if (upBuffera[i] > upBuffera[i+1]) histoup[i] = 1;;
            if (upBuffera[i] < upBuffera[i+1]) histodn[i] = 1;;
   }
   return(0);
}