//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  C'225,0,0'
#property indicator_color2  C'0,225,0'
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    StochasticLength1 =  5;
extern int    StochasticLength2 =  8;
extern int    StochasticLength3 = 13;
extern int    StochasticLength4 = 21;
extern int    StochasticLength5 = 34;
extern int    StochasticLength6 = 55;
extern int    StochasticLength7 = 89;
extern int    StochasticLength8 = 144;
extern double SmoothEMA         = 3;
extern int    Group             = 7;
extern double LevelUp           = 70;
extern double LevelDown         = 30;
extern double GapUp             = 0.25;
extern double GapDown           = 0.25;

double signalUp[];
double signalDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,signalUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,signalDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   IndicatorShortName("DSS Bressert fan signals");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i = limit; i>=0; i--)
 	{
      int    result = 0;
      double dss;
 	    if (StochasticLength1>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength1,SmoothEMA,i,0); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength2>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength2,SmoothEMA,i,1); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength3>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength3,SmoothEMA,i,2); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength4>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength4,SmoothEMA,i,3); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength5>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength5,SmoothEMA,i,4); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength6>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength6,SmoothEMA,i,5); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength7>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength7,SmoothEMA,i,6); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	    if (StochasticLength8>1)  { dss = iDss(Close[i],High[i],Low[i],StochasticLength8,SmoothEMA,i,7); result += (dss > LevelUp); result -= (dss < LevelDown); }
 	       signalUp[i] = EMPTY_VALUE;
 	       signalDn[i] = EMPTY_VALUE;
 	          if (result>= Group) signalUp[i] = High[i]+iATR(NULL,0,10,i)*GapUp;
 	          if (result<=-Group) signalDn[i] = Low[i] -iATR(NULL,0,10,i)*GapDown;
   } 	    
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDss[][40];
#define _st1    0
#define _ss1    1
#define _pHigh  2
#define _pLow   3
#define _dss    4

double iDss(double close, double high, double low, int length, double smooth, int r, int instanceNo=0)
{
   if (ArrayRange(workDss,0)!=Bars) ArrayResize(workDss,Bars); r=Bars-r-1; instanceNo*=5;
   
   //
   //
   //
   //
   //
   
      double alpha = 2.0 / (1.0+smooth);
         workDss[r][instanceNo+_pHigh]  = high;
         workDss[r][instanceNo+_pLow]   = low;
     
         double min = workDss[r][instanceNo+_pLow];
         double max = workDss[r][instanceNo+_pHigh];
         for (int k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][instanceNo+_pLow]);
            max = MathMax(max,workDss[r-k][instanceNo+_pHigh]);
         }
      
         workDss[r][instanceNo+_st1] = 0;
               if (min!=max) workDss[r][instanceNo+_st1] = 100*(close-min)/(max-min);
         workDss[r][instanceNo+_ss1] = workDss[r-1][instanceNo+_ss1]+alpha*(workDss[r][instanceNo+_st1]-workDss[r-1][instanceNo+_ss1]);

         //
         //
         //
         //
         //
         
         min = workDss[r][instanceNo+_ss1];
         max = workDss[r][instanceNo+_ss1];
         for (k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][instanceNo+_ss1]);
            max = MathMax(max,workDss[r-k][instanceNo+_ss1]);
         }
         double stoch = 0; if (min!=max) stoch = 100*(workDss[r][instanceNo+_ss1]-min)/(max-min);
         
         //
         //
         //
         //
         //
         
          workDss[r][instanceNo+_dss] = workDss[r-1][instanceNo+_dss]+alpha*(stoch -workDss[r-1][instanceNo+_dss]);
   return(workDss[r][instanceNo+_dss]);
}

