//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property indicator_level2  80
#property indicator_level3  20
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern string TimeFrame              = "Current time frame";
extern int    KPeriod                = 5;
extern int    DPeriod                = 3;
extern int    Slowing                = 3;
extern int    Price                  = 0; 
extern int    MaMethod               = 0;
extern double T3Period               = 5;
extern int    T3Price                = PRICE_CLOSE;
extern double T3Hot                  = 0.618;
extern bool   T3Original             = true;
extern bool   ColorOnSlope           = true;
extern int    Shift                  = 0;


extern int    BarsPerSymbol          = 100;
extern string Symbols                = "EURUSD;GBPUSD;USDCHF";
extern string UniqueID               = "Multi pair T3 stochastic";
extern string _                      = "separator colors";
extern color  textColor              = Black;
extern color  backColor              = DarkGray;
extern color  signalCrossUpColor     = LimeGreen;
extern color  signalCrossDownColor   = HotPink;
extern int    separatorWidth         = 6;

//
//
//
//
//
double Stochastic[];
double StochasticDa[];
double StochasticDb[];
double Stochastic_Signal[];
double state[];
double cg[];
double storaw[];

//
//
//
//
//

int      window;  
string   aPairs[];
string   shortName;
double   minValue;
double   maxValue;
double   maxValues[];
int      timeFrame;
bool     calculateValue;
string   indicatorFileName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Stochastic);
   SetIndexBuffer(1,StochasticDa);
   SetIndexBuffer(2,StochasticDb);
   SetIndexBuffer(3,Stochastic_Signal);
      for (int j=0; j<4; j++)  SetIndexShift(j,Shift);
      DPeriod = MathMax(DPeriod,1);
   SetIndexBuffer(4,state);
   SetIndexBuffer(5,cg);
   SetIndexBuffer(6,storaw);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      indicatorFileName = WindowExpertName();

      //
      //
      //
      //
      //

      Symbols = StringTrimLeft(StringTrimRight(Symbols));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   
            
         int s =  0;
         int i =  StringFind(Symbols,";",s);
         while (i > 0)
         {
            string current = StringSubstr(Symbols,s,i-s);
            ArrayResize(aPairs,ArraySize(aPairs)+1);
                        aPairs[ArraySize(aPairs)-1] = current;
                        if (current == Symbol())
                        {
                           string temp      = aPairs[0];
                                  aPairs[0] = current;
                                  aPairs[ArraySize(aPairs)-1] = temp;
                        }                                       
            s = i + 1;
            i = StringFind(Symbols,";",s);
         }
         ArrayResize(maxValues,ArraySize(aPairs));

      //
      //
      //
      //
      //
 
      separatorWidth = MathMax(separatorWidth,4);
      shortName      = UniqueID;
      timeFrame      = stringToTimeFrame(TimeFrame);
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i = 0; i < ArraySize(aPairs); i++)
   { 
         ObjectDelete(shortName+i);
         ObjectDelete(shortName+i+i);
   }         
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (calculateValue) { calculateIndicator(); return(0); }
   int    i,k,limit = ArraySize(aPairs);
   double max;
   
   //
   //
   //
   //
   //

   window = WindowFind(shortName);  
   ArrayInitialize(maxValues,0);
         minValue = 0;
         maxValue = 0;
                for(i=0,k=0; i<limit; i++) calculateValues(aPairs[i],BarsPerSymbol,k,i);
                for(i=0;     i<limit; i++) if (max < maxValues[i]) max = maxValues[i];
                for(i=0,k=0; i<limit; i++) plotGraph(aPairs[i],BarsPerSymbol,k,i,max);
   for (i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Bars-k);
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void plotGraph(string symbol,int limit, int& shift,int element, double max)
{
   for(int i=limit; i>=0; i--)
   {   
      StochasticDa[i+shift] = EMPTY_VALUE;
      StochasticDb[i+shift] = EMPTY_VALUE;
         if (state[i+shift]==-1) PlotPoint(i+shift,StochasticDa,StochasticDb,Stochastic);
   }
   createLabel(symbol,element,shift+limit+separatorWidth-2,max,isSignalCrossing(shift));
   shift += (limit+separatorWidth-1);
}

//
//
//
//
//

int isSignalCrossing(int shift)
{
   double res = (Stochastic[shift]   - Stochastic_Signal[shift])*
                (Stochastic[shift+1] - Stochastic_Signal[shift+1]); 
   return(res<=0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void calculateIndicator()
{
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (state[limit]==-1) CleanPoint(limit,StochasticDa,StochasticDb);


         //
         //
         //
         //
         //

         for (i=limit; i>=0 ; i--)
         {
             if (DPeriod>1)
               Stochastic_Signal[i] = iT3(iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MaMethod,Price,MODE_SIGNAL,i),T3Period,T3Hot,T3Original,i,1);
               Stochastic[i]        = iT3(iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MaMethod,Price,MODE_MAIN  ,i),T3Period,T3Hot,T3Original,i,0);
               StochasticDa[i]      = EMPTY_VALUE;
               StochasticDb[i]      = EMPTY_VALUE;
               state[i]             = state[i+1];
               
               //
               //
               //
               //
               //
               
               if (ColorOnSlope)
               {
                  if (Stochastic[i]>Stochastic[i+1]) state[i] =  1;
                  if (Stochastic[i]<Stochastic[i+1]) state[i] = -1;
               }
               else
               {
                  if (Stochastic[i]>Stochastic_Signal[i+1]) state[i] =  1;
                  if (Stochastic[i]<Stochastic_Signal[i+1]) state[i] = -1;
               }
               if (state[i]==-1) PlotPoint(i,StochasticDa,StochasticDb,Stochastic);
               
         }
}

//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void calculateValues(string symbol,int limit,int& shift,int element)
{
   for(int i=0; i<limit; i++)
   {
      int y=iBarShift(NULL,timeFrame,Time[i]);
         Stochastic[i+shift]   = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",KPeriod,DPeriod,Slowing,MaMethod,Price,T3Period,T3Price,T3Hot,T3Original,0,y);
         Stochastic_Signal[i+shift]  = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",KPeriod,DPeriod,Slowing,MaMethod,Price,T3Period,T3Price,T3Hot,T3Original,3,y);
         state[i+shift]   = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",KPeriod,DPeriod,Slowing,MaMethod,Price,T3Period,T3Price,T3Hot,T3Original,4,y);
      maxValues[element] = MathMax(MathAbs(Stochastic[i+shift]),maxValues[element]);
      maxValue           = MathMax(Stochastic[i+shift],maxValue);
      minValue           = MathMin(Stochastic[i+shift],minValue);
   }            

   //
   //
   //
   //
   //

   for (i=0;i<separatorWidth;i++) {
         Stochastic[shift+limit+i]   = EMPTY_VALUE;
         StochasticDa[shift+limit+i] = EMPTY_VALUE;
         StochasticDb[shift+limit+i] = EMPTY_VALUE;
         Stochastic_Signal[shift+limit+i]  = EMPTY_VALUE;
      }         
   shift += (limit+separatorWidth-1);
   return;
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void createLabel(string symbol,int element, int shift, double max, int signalCrossing)
{
   string name = shortName+element;
   double price1 = maxValue;
   double price2 = minValue;
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_TEXT,window,0,0);
            ObjectSet(name,OBJPROP_ANGLE,90);
            ObjectSetText(name,symbol,10,"Arial bold");
      }
      ObjectSet(name,OBJPROP_TIME1 ,Time[shift]);
      ObjectSet(name,OBJPROP_PRICE1,(price1+price2)/2);
      ObjectSet(name,OBJPROP_COLOR,textColor);

   //
   //
   //
   //
   //

   name = shortName+element+element;
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
            ObjectSet(name,OBJPROP_COLOR,backColor);
      }         
      ObjectSet(name,OBJPROP_TIME1,Time[shift]);
      ObjectSet(name,OBJPROP_PRICE1,price1);
      ObjectSet(name,OBJPROP_TIME2,Time[shift-(separatorWidth-2)]);
      ObjectSet(name,OBJPROP_PRICE2,price2);
      if (signalCrossing!=0)
           if (signalCrossing>0)
                  ObjectSet(name,OBJPROP_COLOR,signalCrossUpColor);
           else   ObjectSet(name,OBJPROP_COLOR,signalCrossDownColor);
      else ObjectSet(name,OBJPROP_COLOR,backColor);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//
void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}