//+----------------------------------------------------------+
//|                              Ehlers fisher transform.mq4 |
//|                                                   mladen |
//+----------------------------------------------------------+
//mod2008fxtsd  Ehlers_Fisher_transform_over_STO.mq4

#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  YellowGreen

#property  indicator_width1  1
#property  indicator_style2  0 //STYLE_DOT


#property indicator_level1  0.80
#property indicator_level2 -0.80
#property indicator_levelcolor DarkSlateGray



//
//
//
//
//
 
extern int  EFTperiod        = 10;


extern int KPeriod=14;
extern int DPeriod=3;
extern int Slowing=1;
extern int MAMethod=0;
extern int PriceField=0;



extern string PriceField_  = "0=Hi/Low   1=Close/Close";
extern string MA_Method_   = "SMA0 EMA1 SMMA2 LWMA3";


extern bool   stoKDmodeMain   =  true;

extern bool showSignalLine = true;

//
//
//
//
//

double buffer1[];
double buffer2[];
double Prices[];
double Values[];

   
//+----------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);
      SetIndexBuffer(2,Prices);
      SetIndexBuffer(3,Values);
   IndicatorShortName("Ehlers\' Fisher transform over STO ( "+EFTperiod+"; ("+KPeriod+","+DPeriod+","+Slowing+") ");
   return(0);
}


//+----------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------+
//
//
//
//
//

int start()
{
   int  counted_bars=IndicatorCounted();
   int  i,limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = Bars-counted_bars;

   //
   //
   //
   //
   //
         
   for(i=limit; i>=0; i--)
   {  

               if (stoKDmodeMain) int KDmode =0;   else KDmode =1;
               
      Prices[i] = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MAMethod,PriceField,KDmode,i);


      //
      //
      //
      //
      //
                  
         double MaxH = Prices[ArrayMaximum(Prices,EFTperiod,i)];
         double MinL = Prices[ArrayMinimum(Prices,EFTperiod,i)];
         if (MaxH!=MinL)
               Values[i] = 0.33*2*((Prices[i]-MinL)/(MaxH-MinL)-0.5)+0.67*Values[i+1];
         else  Values[i] = 0.00;
               Values[i] = MathMin(MathMax(Values[i],-0.999),0.999); 

      // 
      //
      //
      //
      //

      buffer1[i] = 0.25*MathLog((1+Values[i])/(1-Values[i]))+0.25*buffer1[i+1];
      if (showSignalLine)
            buffer2[i] = buffer1[i+1];
   }
   return(0);
}