//+------------------------------------------------------------------+
//|                                               Filter overWPR.mq4 |
//|                   Copyright  2006, Indoforex Groups - Primajaya |
//|                                   http://primaforex.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Indoforex Groups"
#property link      "http://primaforex.blogspot.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1.00
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 RoyalBlue
#property indicator_color4 DarkOrange
#property indicator_color5 DodgerBlue
#property indicator_color6 Gold
#property indicator_color7 SkyBlue
#property indicator_color8 Yellow

#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 4
#property indicator_width6 4
#property indicator_width7 4
#property indicator_width8 4

//---- input parameters
extern int PeriodeStoch=14;
extern int PercentD=3;
extern int Smooth=3;
extern bool modeK=true;

//---- indicator buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double UpBuffer3[];
double DnBuffer3[];
double UpBuffer4[];
double DnBuffer4[];






//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexStyle(7,DRAW_HISTOGRAM);
  
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexBuffer(2,UpBuffer2);
   SetIndexBuffer(3,DnBuffer2);
   SetIndexBuffer(4,UpBuffer3);
   SetIndexBuffer(5,DnBuffer3);
   SetIndexBuffer(6,UpBuffer4);
   SetIndexBuffer(7,DnBuffer4);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="PJ filter overSTO("+PeriodeStoch+") ";
   IndicatorShortName(short_name);

   SetIndexLabel(0,"sto>80");
   SetIndexLabel(1,"sto<20");
   SetIndexLabel(2,"sto>60");
   SetIndexLabel(3,"sto>20");
   SetIndexLabel(4,"sto>55");
   SetIndexLabel(5,"sto>40");
   SetIndexLabel(6,"sto>50");
   SetIndexLabel(7,"sto>45");

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| ProSol Confirmation                                              |
//+------------------------------------------------------------------+
int start()
  {
   int trend;
   double PK,pk;
   double PD;
  
   int i,limit, counted_bars = IndicatorCounted();
  
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;
   
   
   for(i = limit; i >= 0; i--)   
   
   {	
   
   pk=iStochastic(NULL, 0,PeriodeStoch,PercentD,Smooth,0,0,MODE_MAIN,i);
   PD=iStochastic(NULL, 0,PeriodeStoch,PercentD,Smooth,0,0,MODE_SIGNAL,i);

   if (modeK) PK=pk; else PK=PD;
               
               
	  UpBuffer1[i]=0.0;
	  DnBuffer1[i]=0.0;
	  UpBuffer2[i]=0.0;
	  DnBuffer2[i]=0.0;
	  UpBuffer3[i]=0.0;
	  DnBuffer3[i]=0.0;
	  UpBuffer4[i]=0.0;
	  DnBuffer4[i]=0.0;

if (PK>=0) trend=2;
if (PK>20) trend=4;
if (PK>40) trend=6;
if (PK>45) trend=8;
if (PK>50) trend=7;
if (PK>55) trend=5;
if (PK>60) trend=3;
if (PK>80) trend=1;



	  
	  if (trend==1) 
	  {
	  
	  UpBuffer1[i]=1;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0;
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=0;

	  }
	  if (trend==2) 
	  {
	  
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=1;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0;
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=0;
	  }
	  if (trend==3) 
	  {
	   
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=1;
	  DnBuffer2[i]=0;
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=0;
	  }
	  
	  if (trend==4) 
	  {
	  
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=1; 
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=0;
	  }

	  if (trend==5) 
	  {
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0; 
	  UpBuffer3[i]=1;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=0;
	  }
	  if (trend==6) 
	  {
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0; 
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=1;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=0;
	  }

	  if (trend==7) 
	  {
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0; 
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=1;
	  DnBuffer4[i]=0;
	  }
	  if (trend==8) 
	  {
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0; 
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  UpBuffer4[i]=0;
	  DnBuffer4[i]=1;
	  }


	}
	return(0);	
 }

