//+------------------------------------------------------------------+
//|                                                 Stoch_Env_v1.mq4 |
//|                                                    2007, sashken |
//|                                                                  |
//+------------------------------------------------------------------+
//Stochastic_Env_v2TSsig.mq4

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 Gold
#property indicator_color5 Blue
#property indicator_color6 Green
#property indicator_color7 Red

#property  indicator_width3  2
#property  indicator_width4  2


#property indicator_level1  80
#property indicator_level2  70
#property indicator_level3  50
#property indicator_level4  30
#property indicator_level5  20
#property indicator_levelcolor DarkSlateGray
#property indicator_levelstyle 2



extern int     Stochastic_Kperiod   = 5;
extern int     Stochastic_Dperiod   = 3;
extern int     Stochastic_Slowing   = 3;
extern int     Stochastic_PlusUP    = 0;     //   
extern int     Env_period           = 24;
extern int     Env_shift            = 1;
extern double  Env_deviation        = 28;


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {

//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(4,DRAW_LINE);
   
   
   IndicatorDigits(4);

   IndicatorShortName("Stoch_Env_v2 ("+Stochastic_Kperiod+","+Stochastic_Dperiod+","+Stochastic_Slowing+" ; "+Env_period+", "+DoubleToStr(Env_deviation,2 )+") ");

  }


   return(0);
//----



int deinit()
   {
   for(int i=0;i<Bars;i++)
     {
      ObjectDelete("ELxUP "+DoubleToStr(Time[i],0 ));
      ObjectDelete("EUxUP "+DoubleToStr(Time[i],0 ));
      ObjectDelete("ELxDN "+DoubleToStr(Time[i],0 ));
      ObjectDelete("EUxDN "+DoubleToStr(Time[i],0 ));
      }

return(0);
   } 
 
 
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+

int start()
  {
   int    i,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   
   limit=Bars-counted_bars;
  
   
   for(i=0;i<limit;i++)
   {
   ExtMapBuffer1[i] = iStochastic(NULL, 0, Stochastic_Kperiod, Stochastic_Dperiod, Stochastic_Slowing,MODE_SMA,0,MODE_MAIN, i)+Stochastic_PlusUP;
   ExtMapBuffer2[i] = iStochastic(NULL, 0, Stochastic_Kperiod, Stochastic_Dperiod, Stochastic_Slowing,MODE_SMA,0,MODE_SIGNAL, i)+Stochastic_PlusUP;
   }  
   
   for(i=0;i<limit;i++)
   {
   ExtMapBuffer3[i] = iEnvelopesOnArray(ExtMapBuffer1,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,i);
   ExtMapBuffer4[i] = iEnvelopesOnArray(ExtMapBuffer1,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,i);
   ExtMapBuffer5[i] = (ExtMapBuffer3[i]+ ExtMapBuffer4[i])/2;
   }   



   for(i=0;i<limit;i++)
   {
      if ((ExtMapBuffer1[i+1] <= ExtMapBuffer3[i+1] && ExtMapBuffer1[i] > ExtMapBuffer3[i]))
      {
      //ExtMapBuffer6[i] = Low[1]-5*Point;
      ObjectCreate("ELxUP " + DoubleToStr(Time[i],0), OBJ_ARROW, 0, Time[i], (Low[i+1]-5*Point));
      ObjectSet   ("ELxUP " + DoubleToStr(Time[i],0), OBJPROP_ARROWCODE, 233);
      ObjectSet   ("ELxUP " + DoubleToStr(Time[i],0), OBJPROP_COLOR, Blue);
      }

      if ((ExtMapBuffer1[i+1] <= ExtMapBuffer4[i+1] && ExtMapBuffer1[i] > ExtMapBuffer4[i]))
      {
      //ExtMapBuffer6[i] = Low[1]-5*Point;
      ObjectCreate("EUxUP " + DoubleToStr(Time[i],0), OBJ_ARROW, 0, Time[i], (Low[i+1]-5*Point));
      ObjectSet   ("EUxUP " + DoubleToStr(Time[i],0), OBJPROP_ARROWCODE, 225);
      ObjectSet   ("EUxUP " + DoubleToStr(Time[i],0), OBJPROP_COLOR, DodgerBlue);
      }
   
      if ((ExtMapBuffer1[i+1] >= ExtMapBuffer3[i+1] && ExtMapBuffer1[i] < ExtMapBuffer3[i]))
      {
      //ExtMapBuffer6[i] = Low[1]-5*Point;
      ObjectCreate("ELxDN " + DoubleToStr(Time[i],0), OBJ_ARROW, 0, Time[i], (High[i+1]+5*Point));
      ObjectSet   ("ELxDN " + DoubleToStr(Time[i],0), OBJPROP_ARROWCODE, 226);
      ObjectSet   ("ELxDN " + DoubleToStr(Time[i],0), OBJPROP_COLOR, Magenta);
      }

      if ((ExtMapBuffer1[i+1] >= ExtMapBuffer4[i+1] && ExtMapBuffer1[i] < ExtMapBuffer4[i]))
      {
      //ExtMapBuffer6[i] = Low[1]-5*Point;
      ObjectCreate("EUxDN " + DoubleToStr(Time[i],0), OBJ_ARROW, 0, Time[i], (High[i+1]+5*Point));
      ObjectSet   ("EUxDN " + DoubleToStr(Time[i],0), OBJPROP_ARROWCODE, 234);
      ObjectSet   ("EUxDN " + DoubleToStr(Time[i],0), OBJPROP_COLOR, Red);
      }   
   
   }   


   return(0);
  }
//+------------------------------------------------------------------+