//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Silver
#property indicator_style4  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 100


//
//
//
//
//

extern int    StoKPeriod    = 14;
extern int    StoDPeriod    =  5;
extern int    StoSlowing    =  5;
extern int    StoSignalMode =  MODE_SMA;
extern int    StoPrice      =  0;
extern bool   ColorOnSlope  = false;
//
//
//
//
//

double sto[];
double stoDa[];
double stoDb[];
double signal[];
double state[];


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,sto);
   SetIndexBuffer(1,stoDa);
   SetIndexBuffer(2,stoDb);
   SetIndexBuffer(3,signal);
   SetIndexBuffer(4,state);
      IndicatorShortName("Stochastic ("+StoKPeriod+","+StoDPeriod+","+StoSlowing+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      if (state[limit] ==-1) CleanPoint(limit,stoDa,stoDb);
      for(i=limit; i>=0; i--) 
      {
         sto[i]    = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,StoSignalMode,StoPrice,MODE_MAIN  ,i);
         signal[i] = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,StoSignalMode,StoPrice,MODE_SIGNAL,i);
         stoDa[i]  = EMPTY_VALUE;
         stoDb[i]  = EMPTY_VALUE;
         state[i]  = state[i+1];
         if (ColorOnSlope)
         {
            if (sto[i] > sto[i+1]) state[i] =  1;
            if (sto[i] < sto[i+1]) state[i] = -1;
         }
         else
         {
            if (sto[i] > signal[i]) state[i] =  1;
            if (sto[i] < signal[i]) state[i] = -1;
         }            
            if (state[i] ==-1) PlotPoint(i,stoDa,stoDb,sto);
      }      
      return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}