//+------------------------------------------------------------------+
//|                                               Stochastic 6TF.mq4 |
//|                                     made by : mladen's disciples |
//+------------------------------------------------------------------+
#property copyright   "this is public domain software"
#property link        "www.forex-tsd.com"
#define indicatorName "Stochastic 6TF"

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  White
#property indicator_color6  RoyalBlue
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  20
#property indicator_level3  80

//
//
//
//
//

extern string TimeFrame1            = "Current time frame";
extern string TimeFrame2            = "next1";
extern string TimeFrame3            = "next2";
extern string TimeFrame4            = "next3";
extern string TimeFrame5            = "next4";
extern string TimeFrame6            = "next5";
extern int    Kperiod               = 11;
extern int    Dperiod               =  3;
extern int    Slowing               =  3;
extern int    PriceField            =  0;
extern int    MAMethod              = MODE_SMA;

//
//
//
//
//

double sto1[];
double sto2[];
double sto3[];
double sto4[];
double sto5[];
double sto6[];

int    timeFrames[6];
bool   returnBars;
string indicatorFileName,shortName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,sto1);
   SetIndexBuffer(1,sto2);
   SetIndexBuffer(2,sto3);
   SetIndexBuffer(3,sto4);
   SetIndexBuffer(4,sto5);
   SetIndexBuffer(5,sto6);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1=="returnBars"); if (returnBars) return(0);
      
      //
      //
      //
      //
      //

      timeFrames[0] = stringToTimeFrame(TimeFrame1);
      timeFrames[1] = stringToTimeFrame(TimeFrame2);
      timeFrames[2] = stringToTimeFrame(TimeFrame3);
      timeFrames[3] = stringToTimeFrame(TimeFrame4);
      timeFrames[4] = stringToTimeFrame(TimeFrame5);
      timeFrames[5] = stringToTimeFrame(TimeFrame6);
      shortName = indicatorName+" ("+Kperiod+","+Dperiod+","+Slowing+")";
      IndicatorShortName(shortName);
   return(0);
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _up 0
#define _dn 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { sto1[0] = limit+1; return(0); }

         if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
         if (timeFrames[1] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[1],indicatorFileName,"returnBars",0,0)*timeFrames[1]/Period()));
         if (timeFrames[2] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[2],indicatorFileName,"returnBars",0,0)*timeFrames[2]/Period()));
         if (timeFrames[3] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[3],indicatorFileName,"returnBars",0,0)*timeFrames[3]/Period()));
         if (timeFrames[4] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[4],indicatorFileName,"returnBars",0,0)*timeFrames[4]/Period()));
         if (timeFrames[5] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[5],indicatorFileName,"returnBars",0,0)*timeFrames[5]/Period()));
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //
    
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      trend[r][_up] = 0;
      trend[r][_dn] = 0;
      for (int k=0; k<6; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
            switch (k)
            {
               case 0: sto1[i] = iStochastic(NULL,timeFrames[k],Kperiod,Dperiod,Slowing,MAMethod,PriceField,0,y); break;
               case 1: sto2[i] = iStochastic(NULL,timeFrames[k],Kperiod,Dperiod,Slowing,MAMethod,PriceField,0,y); break;
               case 2: sto3[i] = iStochastic(NULL,timeFrames[k],Kperiod,Dperiod,Slowing,MAMethod,PriceField,0,y); break;
               case 3: sto4[i] = iStochastic(NULL,timeFrames[k],Kperiod,Dperiod,Slowing,MAMethod,PriceField,0,y); break;
               case 4: sto5[i] = iStochastic(NULL,timeFrames[k],Kperiod,Dperiod,Slowing,MAMethod,PriceField,0,y); break;
               case 5: sto6[i] = iStochastic(NULL,timeFrames[k],Kperiod,Dperiod,Slowing,MAMethod,PriceField,0,y); break;
            }
      }
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }
       nxt = (StringFind(tfs,"NEXT4")>-1); if (nxt>0) { tfs = ""+Period(); add=4; }
       nxt = (StringFind(tfs,"NEXT5")>-1); if (nxt>0) { tfs = ""+Period(); add=5; }

      //
      //
      //
      //
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}