//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Red
#property indicator_color2     Orange
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    StoKPeriod                = 14;
extern int    StoDPeriod                = 7;
extern int    StoSlowing                = 5;
extern int    StoMAMethod               = 0;
extern int    StoPriceField             = 0;
extern string stoPriceField_            = "0=Hi/Low   1=Close/Close";
extern string stoMA_Method_             = "SMA0 EMA1 SMMA2 LWMA3";
extern string stoKDLine_mode_           = "0 %K, 1 %D";
extern int    stoKDmode                 = 0;
extern double SmoothingLength           = 25;
extern int    AdaptPeriod               = 25;
extern int    SigMa_Period              = 3;
extern int    SigMa_Method              = 0;
extern double levelOb                   = 80;
extern double levelOs                   = 20;

extern bool   alertsOn                  = true;
extern bool   alertsOnObOsSigCross      = true;
extern bool   alertsOnSignalCross       = false;
extern bool   alertsOnLeavingObOs       = false;
extern bool   alertsOnCurrent           = false;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = false;
extern bool   alertsNotify              = false;
extern bool   alertsEmail               = false;

extern bool   arrowsVisible             = false;
extern string arrowsIdentifier          = "smootherstoch arrows1";
extern double arrowsUpperGap            = 1.0;
extern double arrowsLowerGap            = 1.0;

extern bool   arrowsOnObOsSigCross      = true;
extern color  arrowsObOsSigCrossUpColor = LimeGreen;
extern color  arrowsObOsSigCrossDnColor = Red;
extern int    arrowsObOsSigCrossUpCode  = 241;
extern int    arrowsObOsSigCrossDnCode  = 242;
extern int    arrowsObOsSize            = 2;

extern bool   arrowsOnSignCross        = false;
extern color  arrowsSignCrossUpColor   = DeepSkyBlue;
extern color  arrowsSignCrossDnColor   = PaleVioletRed;
extern int    arrowsSignCrossUpCode    = 159;
extern int    arrowsSignCrossDnCode    = 159;
extern int    arrowsSignCrossSize      = 5;

extern bool   arrowsOnLeavingObOs      = false;
extern color  arrowsLeavingObOsUpColor = DodgerBlue;
extern color  arrowsLeavingObOsDnColor = OrangeRed;
extern int    arrowsLeavingObOsUpCode  = 241;
extern int    arrowsLeavingObOsDnCode  = 242;
extern int    arrowsLeavingObOsSize    = 3;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double stoch[];
double trend1[];
double trend2[];
double trend3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Buffer1); //STO
   SetIndexBuffer(1,Buffer2);//STOMA
   SetIndexBuffer(2,stoch);
   SetIndexBuffer(3,trend1);
   SetIndexBuffer(4,trend2);
   SetIndexBuffer(5,trend3);
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
  
   IndicatorShortName("Stoch Adaptive Smoother ("+StoKPeriod+","+StoDPeriod+","+StoSlowing+" ; "+DoubleToStr(SmoothingLength,2)+","+AdaptPeriod+")");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   deleteArrows();

return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
       
   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--) stoch[i] = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,StoMAMethod,StoPriceField,stoKDmode,i);
   for (i=limit; i>=0; i--)
   {
      double dev = iStdDev(NULL,0,AdaptPeriod,0,MODE_SMA,PRICE_CLOSE,i);
      double avg = iSma(dev,AdaptPeriod,i,0);
         if (dev!=0) 
                double period = SmoothingLength*avg/dev;
         else          period = SmoothingLength; 
         if (period<3) period = 3;
         
         //
         //
         //
         //
         //
         
         Buffer1[i] = iSmooth(stoch[i],period,i,0);
    }
    for (i=limit; i>=0; i--)
    {
       Buffer2[i] = iMAOnArray(Buffer1,0,SigMa_Period,0,SigMa_Method,i);
       trend1[i]  = 0;
       trend2[i]  = trend2[i+1];
       trend3[i]  = 0;
       if (Buffer1[i]<levelOs && Buffer1[i]>Buffer2[i])                   trend1[i] = 1;
       if (Buffer1[i]>levelOb && Buffer1[i]<Buffer2[i])                   trend1[i] =-1;
        
       if (Buffer1[i]>Buffer2[i]&&Buffer1[i]>levelOs&&Buffer1[i]<levelOb) trend2[i] = 1; 
       if (Buffer1[i]<Buffer2[i]&&Buffer1[i]>levelOs&&Buffer1[i]<levelOb) trend2[i] =-1; 
            
       if (Buffer1[i]>levelOb)                                            trend3[i] = 1;
       if (Buffer1[i]<levelOs)                                            trend3[i] =-1;  
       manageArrow(i);
   }
   manageAlerts();
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSmooth[][5];
double iSmooth(double price, double length, int r, int instanceNo=0)
{
   if (ArrayRange(workSmooth,0)!=Bars) ArrayResize(workSmooth,Bars); instanceNo *= 5; r = Bars-r-1;
 	if(r<=2) { workSmooth[r][instanceNo] = price; workSmooth[r][instanceNo+2] = price; workSmooth[r][instanceNo+4] = price; return(price); }
   
   //
   //
   //
   //
   //
   
	double alpha = 0.45*(length-1.0)/(0.45*(length-1.0)+2.0);
   	  workSmooth[r][instanceNo+0] =  price+alpha*(workSmooth[r-1][instanceNo]-price);
	     workSmooth[r][instanceNo+1] = (price - workSmooth[r][instanceNo])*(1-alpha)+alpha*workSmooth[r-1][instanceNo+1];
	     workSmooth[r][instanceNo+2] =  workSmooth[r][instanceNo+0] + workSmooth[r][instanceNo+1];
	     workSmooth[r][instanceNo+3] = (workSmooth[r][instanceNo+2] - workSmooth[r-1][instanceNo+4])*MathPow(1.0-alpha,2) + MathPow(alpha,2)*workSmooth[r-1][instanceNo+3];
	     workSmooth[r][instanceNo+4] =  workSmooth[r][instanceNo+3] + workSmooth[r-1][instanceNo+4]; 
   return(workSmooth[r][instanceNo+4]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":3:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnObOsSigCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i] == 1) drawArrow("1",0.5,i,arrowsObOsSigCrossUpColor,arrowsObOsSigCrossUpCode,arrowsObOsSize,false);
         if (trend1[i] ==-1) drawArrow("1",0.5,i,arrowsObOsSigCrossDnColor,arrowsObOsSigCrossDnCode,arrowsObOsSize, true);
      } 
      if (arrowsOnSignCross && trend2[i] != trend2[i+1])
      {
         if (trend2[i] == 1) drawArrow("2",1,i,arrowsSignCrossUpColor,arrowsSignCrossUpCode,arrowsSignCrossSize,false);
         if (trend2[i] ==-1) drawArrow("2",1,i,arrowsSignCrossDnColor,arrowsSignCrossDnCode,arrowsSignCrossSize, true);
      }
      if (arrowsOnLeavingObOs && trend3[i] != trend3[i+1])
      {
         if (trend3[i+1] == -1 && trend3[i] !=-1) drawArrow("3",1.5,i,arrowsLeavingObOsUpColor,arrowsLeavingObOsUpCode,arrowsLeavingObOsSize,false);
         if (trend3[i+1] ==  1 && trend3[i] != 1) drawArrow("3",1.5,i,arrowsLeavingObOsDnColor,arrowsLeavingObOsDnCode,arrowsLeavingObOsSize, true);
      }                                  
   }         
}       

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnObOsSigCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," Stoch Adaptive Smoother crossed signal inside OS zone");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," Stoch Adaptive Smoother crossed signal inside OB zone");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," Stoch Adaptive Smoother crossed signal outside OS/OB zone");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," Stoch Adaptive Smoother crossed signal outside OS/OB zone");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnLeavingObOs && trend3[whichBar] != trend3[whichBar+1])
         {
            if (trend3[whichBar+1] == -1 && trend3[whichBar] !=-1) doAlert(time3,mess3,whichBar," Stoch Adaptive Smoother leaving oversold zone");
            if (trend3[whichBar+1] ==  1 && trend3[whichBar] != 1) doAlert(time3,mess3,whichBar," Stoch Adaptive Smoother leaving overbought zone");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Stoch Adaptive Smoother "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}