//+------------------------------------------------------------------+
//|                                             Color Stochastic.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
//mods BLUR71
//mod2009fxtsd

#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers   6

#property indicator_color1 DarkViolet
#property indicator_color2 Orange
#property indicator_color3 Lime 
#property indicator_color4 Red 
#property indicator_color5 Lime 
#property indicator_color6 Red 

#property indicator_style1 STYLE_DOT
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1

#property indicator_level1 80
#property indicator_level2 20
#property indicator_levelcolor SlateGray

#property indicator_maximum 100
#property indicator_minimum 0

#define SignalName "StochasticSignal"
 


//---- input parameters
//
//    nice setings for trend = 35,10,1
//
//

extern int	timeFrame	= 0;		// {1=M1, 5=M5, 15=M15, ..., 1440=D1, 10080=W1, 43200=MN1}

extern string note = "Stochastic settings";
extern int       KPeriod       =   10,
                 DPeriod       =   3,
                 Slowing       =   3;
extern int       MAMethod      =   3;
extern int       PriceField    =   1;

extern int       OverBoughtLv    =  80;
extern int       OverSoldLv      =  20;

extern bool          ObosLnMode      = true,
                     DirectionLnMode = true,

                     stoHisto       = false,
                     obosHisto      = false,

                     stoArrows      = true,
                     obosArrows     = true,

                     stoBar100      = false,
                     obosBar100     = false,



                 arrowSig_chart= false,
                 alertsOn      = false,
                 alertsMessage = true,
                 alertsSound   = true,
                 alertsEmail   = false;


extern string note_MAMethod = "0=sma, 1=ema, 2=smma, 3=lwma";
extern string note_PriceField = "0=high/low, 1=close/close";


//---- buffers
//
//
//
//
//

double   KFull[],
         DFull[],
         Upper[],
         Lower[],
         Uptrend[],
         Downtrend[];

//
//
//
//
//

int      TimeFrame;
datetime TimeArray[];
int      maxArrows;
int      SignalGap;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{

      SetIndexBuffer(0,DFull);
      SetIndexBuffer(1,KFull);
      SetIndexBuffer(2,Upper);
      SetIndexBuffer(3,Lower);
      SetIndexBuffer(4,Uptrend);
      SetIndexBuffer(5,Downtrend);
         
         //
         //
         //
         //
         //
         
            SetIndexStyle(0,DRAW_LINE);
            SetIndexStyle(1,DRAW_LINE);
            SetIndexStyle(2,DRAW_NONE);
            SetIndexStyle(3,DRAW_NONE);
            SetIndexStyle(4,DRAW_NONE);
            SetIndexStyle(5,DRAW_NONE);
            SetIndexLabel(0,NULL);
            SetIndexLabel(1,NULL);
            SetIndexLabel(2,"Stoup");
            SetIndexLabel(3,"Stodn");
            SetIndexLabel(4,"Stoup1");
            SetIndexLabel(5,"Stodn1");
      
              
      if (obosArrows)   {
            SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);SetIndexEmptyValue(2,EMPTY_VALUE);
            SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);SetIndexEmptyValue(3,EMPTY_VALUE);
                        }
                        
      if (obosHisto)    {

            SetIndexStyle(2,DRAW_HISTOGRAM);
            SetIndexStyle(3,DRAW_HISTOGRAM);
                        }
             
      if (stoArrows)    {
            SetIndexStyle(4,DRAW_ARROW);SetIndexArrow(4,159);SetIndexEmptyValue(4,EMPTY_VALUE);
            SetIndexStyle(5,DRAW_ARROW);SetIndexArrow(5,159);SetIndexEmptyValue(5,EMPTY_VALUE);
                        }
      
      if (stoHisto)     {
            SetIndexStyle(4,DRAW_HISTOGRAM);
            SetIndexStyle(5,DRAW_HISTOGRAM);
                        }
                        
                        
              
           if (ObosLnMode||DirectionLnMode)
 
            {
            SetIndexLabel(0,"Sto sig");
            SetIndexLabel(1,"Sto main");
            SetIndexLabel(2,NULL);
            SetIndexLabel(3,NULL);
            SetIndexLabel(4,NULL);
            SetIndexLabel(5,NULL);
            SetIndexStyle(0,DRAW_LINE);
            SetIndexStyle(1,DRAW_LINE);
            SetIndexStyle(2,DRAW_LINE);
            SetIndexStyle(3,DRAW_LINE);
            SetIndexStyle(4,DRAW_LINE);
            SetIndexStyle(5,DRAW_LINE);
            
            DPeriod = MathMax(DPeriod,1);
            if (DPeriod==1)   {
                  SetIndexStyle(0,DRAW_NONE);
                  SetIndexLabel(0,NULL);
                           }
            else              {
                  SetIndexStyle(0,DRAW_LINE); 
                  SetIndexLabel(0,"Signal");
                           }           
                   
            }
         //
         //
         //
         //
         //
         
   TimeFrame        =stringToTimeFrame(timeFrame);
   string shortName = "Stochastic ("+TimeFrameToString(TimeFrame)+","+KPeriod+","+DPeriod+","+Slowing+","+maDescription(MAMethod)+","+priceDescription(PriceField);
         if (OverBoughtLv < OverSoldLv) OverBoughtLv = OverSoldLv;
         if (OverBoughtLv < 100)      shortName  = shortName+","+OverBoughtLv;
         if (OverSoldLv   >   0)      shortName  = shortName+","+OverSoldLv;
   IndicatorShortName(shortName+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   DeleteArrows();
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int    counted_bars=IndicatorCounted();
   int    limit;
   int    i,y;
   
   
   
   
   if(counted_bars<0) return(-1);
         limit=MathMax(Bars-counted_bars,TimeFrame/Period());
         ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
            
      
   //
   //
   //
   //
   //
   
   for(i=0,y=0; i<limit; i++)
      {
         if(Time[i]<TimeArray[y]) y++;
            KFull[i] = iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,y);
            DFull[i] = iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_SIGNAL,y);
      }
  
  
  
   for(i=limit,y=0; i>=0; i--)
      {
    
    
             
         if(ObosLnMode)
            {
               if (KFull[i] > OverBoughtLv)  { Upper[i] = KFull[i]; Upper[i+1] = KFull[i+1]; }
               else                          { Upper[i] = EMPTY_VALUE;
                                             if (  Upper[i+2] == EMPTY_VALUE)
                                                   Upper[i+1]  = EMPTY_VALUE; }
               if (KFull[i] < OverSoldLv)    { Lower[i] = KFull[i]; Lower[i+1] = KFull[i+1]; }
               else                          { Lower[i] = EMPTY_VALUE;
                                             if (  Lower[i+2] == EMPTY_VALUE)
                                                   Lower[i+1]  = EMPTY_VALUE; }
            }                                                


         else
         
         if (DirectionLnMode)

            {
              
                             Upper[i] = EMPTY_VALUE;  Lower[i] = EMPTY_VALUE;
                             Uptrend[i]= EMPTY_VALUE; Downtrend[i]= EMPTY_VALUE;

               if (KFull[i] > KFull[i+1]) 
               { 
               
               
                  if (KFull[i+1] > KFull[i+2]) //TheXpert's cc
                  {
                     if (Upper[i+1]!=EMPTY_VALUE)  Upper[i]    =KFull[i];
                     else                          Uptrend[i]  =KFull[i];
                  }
                  else
                  {
                     if (Upper[i+2]==EMPTY_VALUE)
                           {  Upper[i]    =KFull[i];  Upper[i+1]    =KFull[i+1];}
                     else  {  Uptrend[i]  =KFull[i];  Uptrend[i+1]  =KFull[i+1];}
                  }
               }
               
               if (KFull[i] < KFull[i+1]) 

               { 
               
                  if (KFull[i+1] < KFull[i+2]) 
                  {
                     if (Lower[i+1]!=EMPTY_VALUE)  Lower[i]      =KFull[i];
                     else                          Downtrend[i]  =KFull[i];
                  }
                  else
                  {
                     if (Lower[i+2]==EMPTY_VALUE)
                           {  Lower[i]    =KFull[i];  Lower[i+1]     =KFull[i+1];}
                     else  {  Downtrend[i]=KFull[i];  Downtrend[i+1] =KFull[i+1];}
                  }
               
               }


         }      //dir                                          
     
     
     

          else

            {
               Upper[i]     = EMPTY_VALUE;
               Lower[i]     = EMPTY_VALUE;
               
               double histo = KFull[i]; if (stoBar100||obosBar100) histo =100;
               while(true)
                  {
                     if (KFull[i] > OverBoughtLv) { if (obosArrows||obosHisto)Upper[i]=OverBoughtLv;if(obosBar100) Upper[i]  = histo;  }//break;
                     if (KFull[i] < OverSoldLv)   { if (obosArrows||obosHisto)Lower[i]=OverSoldLv;if(obosBar100) Lower[i]  = histo; }//break;
                     if (KFull[i] > KFull[i+1]) { Uptrend[i]   = histo; break;}
                     if (KFull[i] < KFull[i+1]) { Downtrend[i] = histo; break;}
                        Uptrend[i]   = Uptrend[i+1];
                        Downtrend[i] = Downtrend[i+1];
                     break;
                  }
            }


      }

   //
   //
   //
   //
   //

   DeleteArrows();
   if (arrowSig_chart)
      {
         SignalGap = MathCeil(iATR(NULL,0,50,0)/Point);
         for (i=0; i<WindowBarsPerChart() ;i++)
            {
               if (KFull[i]>OverBoughtLv && KFull[i+1]<OverBoughtLv) DrawArrow(i,"up");
               if (KFull[i]<OverSoldLv   && KFull[i+1]>OverSoldLv)   DrawArrow(i,"down");
            }
      }            
   if (alertsOn)
         {
            if (KFull[0]>OverBoughtLv && KFull[1]<OverBoughtLv) doAlert(" Maxing going up");
            if (KFull[0]<OverBoughtLv && KFull[1]>OverBoughtLv) doAlert(" **SELL**");//added this line
            if (KFull[0]<OverSoldLv   && KFull[1]>OverSoldLv)   doAlert(" Maxing going down");//corrected this
            if (KFull[0]>OverSoldLv   && KFull[1]<OverSoldLv)   doAlert(" **BUY**");//added this line
         }
   
   //
   //
   //
   //
   //
 
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawArrow(int i,string type)
{
   maxArrows++;
      string name = StringConcatenate(SignalName,maxArrows);
         
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      if (type=="up")
         {
            ObjectSet(name,OBJPROP_PRICE1,High[i]+(SignalGap*Point));
            ObjectSet(name,OBJPROP_ARROWCODE,242);
            ObjectSet(name,OBJPROP_COLOR,Red);
         }
      else
         {
            ObjectSet(name,OBJPROP_PRICE1,Low[i]-(SignalGap*Point));
            ObjectSet(name,OBJPROP_ARROWCODE,241);
            ObjectSet(name,OBJPROP_COLOR,LimeGreen);
         }
}
void DeleteArrows()
{
   while(maxArrows>0) { ObjectDelete(StringConcatenate(SignalName,maxArrows)); maxArrows--; }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];
      
          //
          //
          //
          //
          //
            
          message =  StringConcatenate(Symbol()," Color Stoch",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsSound)   PlaySound("alert2.wav");
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Stochastic crossing"),message);
      }        
}


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

string priceDescription(int mode)
{
   string answer;
   switch(mode)
   {
      case 0:  answer = "Low/High"    ; break; 
      case 1:  answer = "Close/Close" ; break;
      default: answer = "Invalid price field requested";
                                    Alert(answer);
   }
   return(answer);
}
string maDescription(int mode)
{
   string answer;
   switch(mode)
   {
      case MODE_SMA:  answer = "SMA"  ; break; 
      case MODE_EMA:  answer = "EMA"  ; break;
      case MODE_SMMA: answer = "SMMA" ; break;
      case MODE_LWMA: answer = "LWMA" ; break;
      default:        answer = "Invalid MA mode requested";
                                    Alert(answer);
   }
   return(answer);
}
int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}