//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1	 LightSeaGreen
#property indicator_color2	 Red
#property indicator_level1	 80
#property indicator_level2	 20
#property indicator_maximum 100
#property indicator_minimum 0

//
//
//
//
//

extern int            StoKPeriod      = 14;
extern int            StoDPeriod      = 3;
extern int            StoSlowing      = 3;
extern ENUM_STO_PRICE PriceField      = 0;
extern ENUM_MA_METHOD SignalMode      = MODE_SMA;
extern double         levelOb         = 75;
extern double         levelOs         = 25;
extern bool           alertsOn        = true;
extern bool           alertsOnCurrent = true;
extern bool           alertsMessage   = true;
extern bool           alertsSound     = true;
extern bool           alertsNotify    = false;
extern bool           alertsEmail     = false;
extern string         soundFile       = "alert2.wav";

//
//
//
//
//

double sto[];
double sig[];
double trend[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,sto);
   SetIndexBuffer(1,sig);
   SetIndexBuffer(2,trend);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb); 
     
   IndicatorShortName("Stochastic ("+StoKPeriod+","+StoDPeriod+","+StoSlowing+")");
return(0);
}
int deinit()
{
return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {
       sto[i] = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,PriceField,MODE_MAIN  ,i);
       sig[i] = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,PriceField,MODE_SIGNAL,i);
          trend[i] = 0;
          if (sto[i]>levelOb) trend[i] = 1;
          if (sto[i]<levelOs) trend[i] =-1;  
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar+1] ==  1 && trend[whichBar] != 1) doAlert(whichBar,"sell");
         if (trend[whichBar+1] == -1 && trend[whichBar] !=-1) doAlert(whichBar,"buy");
      } 
   }               
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Stochastic ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Stochastic "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

   