//+------------------------------------------------------------------+
//|                                            Stochastic triple.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
//mod2008fxtsd : Sto momentum sto osma

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    4

#property indicator_color1     Green
#property indicator_color2     Maroon
#property indicator_color3     MediumSlateBlue
#property indicator_color4     CadetBlue

#property indicator_width1     1
#property indicator_width2     1
#property indicator_width3     1
#property indicator_width4     1

//#property indicator_minimum    0
//#property indicator_maximum    100

#property indicator_level1     80
#property indicator_level2     50
#property indicator_level3     20
#property indicator_levelcolor DarkSlateGray



extern int KPeriod      =  10;
extern int DPeriod      =  6;

extern int Slowing      =  4;
extern int MaMode       =  0;
extern int PriceField   =  0;

extern bool    ShowSTO  =  true;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];



//+------------------------------------------------------------------+





int init()
{
   
      IndicatorBuffers(6);
   
   if (ShowSTO){
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);

   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);   
               }
    else       {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
               }    
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_HISTOGRAM);

   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);   

   IndicatorShortName("STO OsMA Momentum ("+KPeriod+","+DPeriod+","+Slowing+") ");  


   SetIndexLabel (0,"StoMain");
   SetIndexLabel (1,"StoSig" );
   SetIndexLabel (2,"Sto0-Sto1 Mom");
   SetIndexLabel (3,"Sto Main-Sig" );


   return(0);
}

//--
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+




int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
                      
      
      buffer6[i] = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MaMode,PriceField,MODE_MAIN,i);
      
      buffer5[i] = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MaMode,PriceField,MODE_SIGNAL,i);
      
      
      buffer4[i] = buffer6[i]-buffer5[i];

      buffer3[i] = buffer6[i]-buffer6[i+1];
   
   if (ShowSTO)   {
      
      buffer2[i] = buffer5[i];
   
      buffer1[i] = buffer6[i];
                  }   
   

   }




   return(0);
}

