//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                      StochasticExpansion_v1.1.mq4|
//| non-repainting, new metatrade 4 compatible version by mladen     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 SteelBlue
#property indicator_color2 OrangeRed
#property indicator_color3 OrangeRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

#property indicator_level1 5
#property indicator_level2 -5
#property indicator_level3 10
#property indicator_level4 10
#property indicator_level5 0



extern int KPeriod1 = 13;
extern int Slowing1 = 6;
extern int NoiseFilter = 6;


double blue[];
double reda[];
double redb[];
double HighesBuffer1[];
double LowesBuffer1[];

double KLineBuffer1[];
double KLineBuffer2[];
double slope[];


int init() {
   IndicatorBuffers(8);
   SetIndexBuffer(0, blue);
   SetIndexBuffer(1, reda);
   SetIndexBuffer(2, redb);
   
   //SetIndexStyle(0, DRAW_HISTOGRAM);SetIndexStyle(1, DRAW_HISTOGRAM);

   SetIndexBuffer(3, HighesBuffer1);
   SetIndexBuffer(4, LowesBuffer1);
   
   SetIndexBuffer(5, KLineBuffer1);
   SetIndexBuffer(6, KLineBuffer2);
   SetIndexBuffer(7, slope);
   IndicatorShortName("StochasticExpansion_v1.1("+KPeriod1+","+Slowing1+")");
   return(0);
}
int limit;
int start(){
    int counted_bars=IndicatorCounted();
    limit = Bars - counted_bars;
    if(counted_bars > 0)  {
        limit = Bars - counted_bars - 1;
    }
    
    minimumsCounting(LowesBuffer1, KPeriod1);
    maximumsCounting(HighesBuffer1, KPeriod1);
    KLine(KLineBuffer1, KLineBuffer2, HighesBuffer1, LowesBuffer1, Slowing1);
    
     if (slope[limit]==-1) CleanPoint(limit,reda,redb);
     for(int i = limit; i >= 0; i--) {
        double value = iMAOnArray(KLineBuffer1, Bars, NoiseFilter, 0, 0, i);
            blue[i] = KLineBuffer1[i];
            reda[i] = EMPTY_VALUE;
            redb[i] = EMPTY_VALUE;
            slope[i] = slope[i+1];     
               if (blue[i]>blue[i+1]) slope[i] =  1;
               if (blue[i]<blue[i+1]) slope[i] = -1;
               if (slope[i]==-1) PlotPoint(i,reda,redb,blue);

    }
    return(0);
}

void minimumsCounting(double &LowesBuffer[], int KPeriod) {
    for(int i = limit; i>=0; i--) {
        LowesBuffer[i] = Low[iLowest(NULL,0,MODE_LOW, KPeriod, i)];
    }
}

void maximumsCounting(double &HighesBuffer[], int KPeriod) {
    for(int i = limit; i>=0; i--) {
        HighesBuffer[i] = High[iHighest(NULL,0,MODE_HIGH, KPeriod, i)];
    }
}

void KLine(double &tKLineBuffer1[], double &tKLineBuffer2[], double& HighesBuffer[], double& LowesBuffer[], int Slowing) {
    for(int i = limit; i>=0; i--) {
        double sumlow=0;
        double sumhigh=0;
        for(int k = i + Slowing - 1; k >= i; k--) {
            sumlow += Close[k] - LowesBuffer[k];
            sumhigh += HighesBuffer[k] - Close[k];
        }
        
        if(sumhigh == 0.0) {
            tKLineBuffer1[i] = 0;
        } else { 
            tKLineBuffer1[i] = sumlow / sumhigh;
        }
        
        if(sumlow == 0.0) {
            tKLineBuffer2[i] = 0;
        } else { 
            tKLineBuffer2[i] = -sumhigh / sumlow;
        }
        
       
       tKLineBuffer1[i] = tKLineBuffer1[i] + tKLineBuffer2[i];
    }
    return;
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
