//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                      StochasticExpansion_v1.1.mq4|
//| non-repainting, new metatrade 4 compatible version by mladen     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 SteelBlue
#property indicator_color2 OrangeRed
#property indicator_color3 OrangeRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_level1 5
#property indicator_level2 -5
#property indicator_level3 10
#property indicator_level4 10
#property indicator_level5 0


extern string TimeFrame        = "Current time frame";
extern int    KPeriod1         = 13;
extern int    Slowing1         = 6;
extern int    NoiseFilter      = 6;
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "stochExp Arrows1";
extern double arrowsUpperGap   = 0.25;
extern double arrowsLowerGap   = 0.25;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;


double blue[];
double reda[];
double redb[];
double HighesBuffer1[];
double LowesBuffer1[];
double KLineBuffer1[];
double KLineBuffer2[];
double slope[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;


int init() 
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, blue);
   SetIndexBuffer(1, reda);
   SetIndexBuffer(2, redb);
   SetIndexBuffer(3, HighesBuffer1);
   SetIndexBuffer(4, LowesBuffer1);
   SetIndexBuffer(5, KLineBuffer1);
   SetIndexBuffer(6, KLineBuffer2);
   SetIndexBuffer(7, slope);
   
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
    timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" StochasticExpansion_v1.1("+KPeriod1+","+Slowing1+")");
   return(0);
}

int deinit() 
{  
   deleteArrows(); 
return(0); 
}
int limit;
int start(){
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { blue[0] = limit+1; return(0); }
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               if (slope[limit]==-1) CleanPoint(limit,reda,redb);
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                      blue[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",KPeriod1,Slowing1,NoiseFilter,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,0,y);
                      reda[i] = EMPTY_VALUE;
                      redb[i] = EMPTY_VALUE;
                      slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",KPeriod1,Slowing1,NoiseFilter,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,7,y);  
                                
               }
               for (i=limit; i>=0; i--) if (slope[i]==-1) PlotPoint(i,reda,redb,blue);
               return(0);
            }
    
     minimumsCounting(LowesBuffer1, KPeriod1);
     maximumsCounting(HighesBuffer1, KPeriod1);
     KLine(KLineBuffer1, KLineBuffer2, HighesBuffer1, LowesBuffer1, Slowing1);
     if (slope[limit]==-1) CleanPoint(limit,reda,redb);
     for(i = limit; i >= 0; i--) {
        double value = iMAOnArray(KLineBuffer1, Bars, NoiseFilter, 0, 0, i);
            blue[i] = KLineBuffer1[i];
            reda[i] = EMPTY_VALUE;
            redb[i] = EMPTY_VALUE;
            slope[i] = slope[i+1];     
               if (blue[i]>blue[i+1]) slope[i] =  1;
               if (blue[i]<blue[i+1]) slope[i] = -1;
               if (slope[i]==-1) PlotPoint(i,reda,redb,blue);
               
               if (ShowArrows)
               {
                 deleteArrow(Time[i]);
                 if (slope[i] != slope[i+1])
                 {
                   if (slope[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                   if (slope[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                 }
               }

    }
    return(0);
}

void minimumsCounting(double &LowesBuffer[], int KPeriod) {
    for(int i = limit; i>=0; i--) {
        LowesBuffer[i] = Low[iLowest(NULL,0,MODE_LOW, KPeriod, i)];
    }
}

void maximumsCounting(double &HighesBuffer[], int KPeriod) {
    for(int i = limit; i>=0; i--) {
        HighesBuffer[i] = High[iHighest(NULL,0,MODE_HIGH, KPeriod, i)];
    }
}

void KLine(double &tKLineBuffer1[], double &tKLineBuffer2[], double& HighesBuffer[], double& LowesBuffer[], int Slowing) {
    for(int i = limit; i>=0; i--) {
        double sumlow=0;
        double sumhigh=0;
        for(int k = i + Slowing - 1; k >= i; k--) {
            sumlow += Close[k] - LowesBuffer[k];
            sumhigh += HighesBuffer[k] - Close[k];
        }
        
        if(sumhigh == 0.0) {
            tKLineBuffer1[i] = 0;
        } else { 
            tKLineBuffer1[i] = sumlow / sumhigh;
        }
        
        if(sumlow == 0.0) {
            tKLineBuffer2[i] = 0;
        } else { 
            tKLineBuffer2[i] = -sumhigh / sumlow;
        }
        
       
       tKLineBuffer1[i] = tKLineBuffer1[i] + tKLineBuffer2[i];
    }
    return;
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}




