//+------------------------------------------------------------------+
//|                                               Stochastic RSI.mq4 |
//|                                                 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "No body it is free"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_width1 2

//---- input parameters
extern int                RSI_Periods=14;
extern ENUM_APPLIED_PRICE RSI_Price = PRICE_TYPICAL;
extern int                Percent_K=14;
extern int                Percent_D=9;
extern int                NumOfBars=0;

//---- buffers
double Buffer1[];
double Buffer2[];
double test1;
double test2;
double alertTag;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,Buffer1);
   SetIndexLabel(0,"StochRSI");
   SetIndexBuffer(1,Buffer2);
   SetIndexLabel(1,"Signal");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   for(int i=limit;i>=0;i--)
   {   
      double Current_RSI=iRSI(NULL,0,RSI_Periods,RSI_Price,i);
      double Highest_RSI=Current_RSI;
      double Lowest_RSI =Current_RSI;
      for(int x=0;x<=Percent_K;x++){
            Lowest_RSI =MathMin(Lowest_RSI ,iRSI(NULL,0,RSI_Periods,RSI_Price,i+x));
            Highest_RSI=MathMax(Highest_RSI,iRSI(NULL,0,RSI_Periods,RSI_Price,i+x));
         }

      double sum_K=0;
      if ((Highest_RSI-Lowest_RSI)!=0)
            Buffer1[i]=((Current_RSI-Lowest_RSI)/(Highest_RSI-Lowest_RSI))*100;
      else  Buffer1[i]=0;
      for(x=0;x<=Percent_D;x++) sum_K+=Buffer1[i+x];
         Buffer2[i]=sum_K/Percent_D;
  
      }

//----
   return(0);
  }
//+------------------------------------------------------------------+