//+------------------------------------------------------------------+
//|                                            StochRSIHistogram.mq4 |
//|                                    Copyright  2008, Robert Hill |
//|                                                                  |
//| Combines Stochastics and RSI in a histogram                      |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Robert Hill"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green //uptrend
#property indicator_width1 2  
#property indicator_color2 IndianRed  //downtrend
#property indicator_width2 2  
#property indicator_color3 DarkGreen // First Stochastic line
#property indicator_width3 2  

extern int    KPeriod=14;
extern int    DPeriod=3;
extern int    SlowingPeriod=3;
extern int    RSIPeriod = 14;

double upB[];
double loB[];
double Stoch1[];
//+------------------------------------------------------------------+
int init() {

   IndicatorBuffers(3);
   
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(0,upB);
   SetIndexEmptyValue(0,EMPTY_VALUE);
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID); //downtrend
   SetIndexBuffer(1,loB);
   SetIndexEmptyValue(1,EMPTY_VALUE);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Stoch1);

   IndicatorShortName("Stoch" + "(" + KPeriod + "," + DPeriod + "," + SlowingPeriod + ")" + " - RSI" + "(" + RSIPeriod + ") Histogram" );

   return(0);
}
//+------------------------------------------------------------------+
int deinit() {
   
   
}
//+------------------------------------------------------------------+
int start() {

   int counted_bars=IndicatorCounted();
   int shift,limit;
   double Stoch, RSI;
   
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
  
   limit=Bars-31;
   if(counted_bars>=0) limit=Bars-counted_bars+2;

   for (shift=limit;shift>=0;shift--)   {
      
      upB[shift] = 0;
      loB[shift] = 0;
      Stoch1[shift] = 0;
      Stoch=iStochastic(NULL,0,KPeriod,DPeriod,SlowingPeriod,MODE_SMA,0,MODE_MAIN,shift);      
      RSI = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, shift);
      Stoch1[shift]=Stoch + RSI - 100;      
      if(Stoch1[shift]>0) {
         
         upB[shift]=Stoch1[shift];
         
      } else if (Stoch1[shift]<0){
      
         loB[shift]=Stoch1[shift];
         
      }
   }
   
   return(0);

}
//+------------------------------------------------------------------+

