
#property copyright ""

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     Green 
#property indicator_width3     2  
#property indicator_color4     IndianRed  
#property indicator_width4     2  
#property indicator_color5     DarkGreen 
#property indicator_width5     2
#property indicator_levelcolor MediumOrchid 

//
//
// 
//
//

extern int    KPeriod                   = 14;
extern int    DPeriod                   = 3;
extern int    SlowingPeriod             = 3;
extern int    RSIPeriod                 = 14;
extern double Uplevel                   = 15;
extern double Dnlevel                   = -15;
extern int    DivergearrowSize          = 1; 
extern bool   drawDivergences           = true;
extern bool   drawIndicatorTrendLines   = true;
extern bool   drawPriceTrendLines       = true;
extern string drawLinesIdentificator    = "StochRsidiverge1";
extern string ___                       = "Divergence Alerts";
extern bool   divergenceAlert           = true;
extern bool   divergenceAlertsMessage   = true;
extern bool   divergenceAlertsSound     = true;
extern bool   divergenceAlertsNotify    = false;
extern bool   divergenceAlertsEmail     = false;
extern string divergenceAlertsSoundName = "alert1.wav";

extern string note                      = "turn on Alert = true; turn off = false";
extern bool   alertsOn                  = false;
extern bool   alertsOnZeroCross         = true;
extern bool   alertsOnLevelCross        = true;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = false;
extern bool   alertsNotify              = false;
extern bool   alertsEmail               = false;
extern string soundFile                 = "alert2.wav";

extern bool   arrowsVisible             = false;
extern string arrowsIdentifier          = "STORSI arrows1";
extern double arrowsUpperGap            = 1.0;
extern double arrowsLowerGap            = 1.0;

extern bool   arrowsOnZeroCross         = true;
extern color  arrowsZeroCrossUpColor    = LimeGreen;
extern color  arrowsZeroCrossDnColor    = Red;
extern int    arrowsZeroCrossUpCode     = 241;
extern int    arrowsZeroCrossDnCode     = 242;

extern bool   arrowsOnLevelCross        = true;
extern color  arrowsLevelCrossUpColor   = LimeGreen;
extern color  arrowsLevelCrossDnColor   = Red;
extern int    arrowsLevelCrossUpCode    = 241;
extern int    arrowsLevelCrossDnCode    = 242;

//
//
//
//
//

double bullishDivergence[];
double bearishDivergence[];
double upB[];
double loB[];
double Stoch1[];
double trend1[];
double trend2[];

string indicatorName;
string labelNames;

double pipMultiplier = 1;

//
//
//
//
//

int init() 
{

   IndicatorBuffers(7);
   SetIndexBuffer(0,bullishDivergence); SetIndexStyle(0,DRAW_ARROW,0,DivergearrowSize); SetIndexArrow(0,233);
   SetIndexBuffer(1,bearishDivergence); SetIndexStyle(1,DRAW_ARROW,0,DivergearrowSize); SetIndexArrow(1,234);  
   SetIndexBuffer(2,upB); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,loB); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Stoch1);
   SetIndexBuffer(5,trend1);
   SetIndexBuffer(6,trend2);
   SetLevelValue(0,0);
   SetLevelValue(1,Uplevel);
   SetLevelValue(2,Dnlevel);
   
       //
       //
       //
       //
       //
       
       labelNames    = "StochRsi_DivergenceLine "+drawLinesIdentificator+":";
       indicatorName = "Stoch" + "("+KPeriod+","+DPeriod+","+SlowingPeriod+")"+"-RSI"+"("+RSIPeriod+")Histogram";
       IndicatorShortName(indicatorName);

   return(0);
}

//
//
//
//
//

int deinit()
{  
   int length=StringLen(labelNames);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringSubstr(name,0,length) == labelNames)  ObjectDelete(name);   
   }
   deleteArrows();

return(0);
}

//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int shift,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (Digits==3 || Digits==5) 
               pipMultiplier = 10;
         else  pipMultiplier = 1; 
   
   //
   //
   //
   //
   //
   
   for (shift=limit;shift>=0;shift--)   
   {
      double Stoch  = iStochastic(NULL,0,KPeriod,DPeriod,SlowingPeriod,MODE_SMA,0,MODE_MAIN,shift);      
      double RSI    = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, shift);
      Stoch1[shift] = Stoch + RSI - 100; 
      
      //
      //
      //
      //
      //
      
      upB[shift] = EMPTY_VALUE;
      loB[shift] = EMPTY_VALUE;
      trend1[shift] = trend1[shift+1];
      trend2[shift] = trend2[shift+1];     
      if(Stoch1[shift]>0)          trend1[shift] = 1;
      if(Stoch1[shift]<0)          trend1[shift] =-1;
      if (Stoch1[shift] > Uplevel) trend2[shift] = 1;
      if (Stoch1[shift] < Dnlevel) trend2[shift] =-1;
      if(trend1[shift] == 1) upB[shift]=Stoch1[shift];  
      if(trend1[shift] ==-1) loB[shift]=Stoch1[shift]; 
      if (drawDivergences)
      {
         CatchBullishDivergence(shift);
         CatchBearishDivergence(shift);
      }            
      manageArrow(shift);
   }
   manageAlerts();
return(0);
}

//
//
//
//
//

void CatchBullishDivergence(int shift)
{
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;  

   //
   //
   //
   //
   //
      
   int currentLow = shift;
   int lastLow    = GetIndicatorLastLow(shift+1);

   //
   //
   //
   //
   //
    
   if(Stoch1[currentLow] > Stoch1[lastLow] && Low[currentLow] < Low[lastLow])
   {
      bullishDivergence[currentLow] = Stoch1[currentLow] - Point*pipMultiplier;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],Green,STYLE_SOLID);
      if(drawIndicatorTrendLines == true)
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],Stoch1[currentLow],Stoch1[lastLow],Green,STYLE_SOLID);
      if(divergenceAlert == true)
                 DisplayAlert("Classical bullish divergence",currentLow);  
                        
   }
     
   //
   //
   //
   //
   //
        
   if(Stoch1[currentLow] < Stoch1[lastLow] && Low[currentLow] > Low[lastLow])
   {
      bullishDivergence[currentLow] = Stoch1[currentLow] - Point*pipMultiplier;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], Green, STYLE_DOT);
      if(drawIndicatorTrendLines == true)                            
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],Stoch1[currentLow], Stoch1[lastLow], Green, STYLE_DOT);
      if(divergenceAlert == true)
                 DisplayAlert("Reverse bullish divergence",currentLow); 
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CatchBearishDivergence(int shift)
{
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift+1);

   //
   //
   //
   //
   //
      
   if(Stoch1[currentPeak] < Stoch1[lastPeak] && High[currentPeak]>High[lastPeak])
   {
       bearishDivergence[currentPeak] = Stoch1[currentPeak] + Point*pipMultiplier;
       if(drawPriceTrendLines == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red,STYLE_SOLID);
       if(drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],Stoch1[currentPeak],Stoch1[lastPeak],Red,STYLE_SOLID);
       if(divergenceAlert == true)
               DisplayAlert("Classical bearish divergence",currentPeak); 
                        
   }
   
   //
   //
   //
   //
   //

   if(Stoch1[currentPeak] > Stoch1[lastPeak] && High[currentPeak] < High[lastPeak])
   {
      bearishDivergence[currentPeak] = Stoch1[currentPeak] + Point*pipMultiplier;
      if (drawPriceTrendLines == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak], Red, STYLE_DOT);
      if (drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],Stoch1[currentPeak],Stoch1[lastPeak], Red, STYLE_DOT);
      if(divergenceAlert == true)
               DisplayAlert("Reverse bearish divergence",currentPeak);
                         
   }   
}

//
//
//
//
//

bool IsIndicatorPeak(int shift)
{
   if(Stoch1[shift] >= Stoch1[shift+1] && Stoch1[shift] > Stoch1[shift+2] && Stoch1[shift] > Stoch1[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

bool IsIndicatorLow(int shift)
{
   if(Stoch1[shift] <= Stoch1[shift+1] && Stoch1[shift] < Stoch1[shift+2] && Stoch1[shift] < Stoch1[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastPeak(int shift)
{
    for(int i = shift+5; i < Bars; i++)
    {
       if(Stoch1[i] >= Stoch1[i+1] && Stoch1[i] > Stoch1[i+2] && Stoch1[i] >= Stoch1[i-1] && Stoch1[i] > Stoch1[i-2])
         return(i);
    }
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastLow(int shift)
{
    for (int i = shift+5; i < Bars; i++)
    {
       if (Stoch1[i] <= Stoch1[i+1] && Stoch1[i] < Stoch1[i+2] && Stoch1[i] <= Stoch1[i-1] && Stoch1[i] < Stoch1[i-2])
         return(i);
}
     
return(-1);
}

//
//
//
//
//

void DisplayAlert(string doWhat, int shift)
{
    string dmessage;
    static datetime lastAlertTime;
    if(shift <= 2 && Time[0] != lastAlertTime)
    {
      dmessage =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," StochRSIHistogram ",doWhat);
          if (divergenceAlertsMessage) Alert(dmessage);
          if (divergenceAlertsNotify)  SendNotification(dmessage);
          if (divergenceAlertsEmail)   SendMail(StringConcatenate(Symbol()," StochRSIHistogram "),dmessage);
          if (divergenceAlertsSound)   PlaySound(divergenceAlertsSoundName); 
          lastAlertTime = Time[0];
    }
}


//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    string label = labelNames+first+"os"+DoubleToStr(t1,0);
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    int indicatorWindow = WindowFind(indicatorName);
    if (indicatorWindow < 0) return;
    
    //
    //
    //
    //
    //
    
    string label = labelNames+first+DoubleToStr(t1,0);
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnZeroCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i] == 1) drawArrow(i,arrowsZeroCrossUpColor,arrowsZeroCrossUpCode,false);
         if (trend1[i] ==-1) drawArrow(i,arrowsZeroCrossDnColor,arrowsZeroCrossDnCode, true);
      } 
      if (arrowsOnLevelCross && trend2[i] != trend2[i+1])
      {
         if (trend2[i] == 1) drawArrow(i,arrowsLevelCrossUpColor,arrowsLevelCrossUpCode,false);
         if (trend2[i] ==-1) drawArrow(i,arrowsLevelCrossDnColor,arrowsLevelCrossDnCode, true);
      }                 
   }         
}       

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnZeroCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," crossed zero up");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," crossed zero down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnLevelCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," crossed upper level up");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," crossed lower level down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)," StochRSIHistogram ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," StochRSIHistogram "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}