//+------------------------------------------------------------------
//|                                              Wallabys Stochastic 
//|
//| original idea for this indicator by Rob Booker
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Silver
#property indicator_color2 Silver
#property indicator_color3 Silver
#property indicator_color4 PaleVioletRed
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_width4 2
#property indicator_level1 20
#property indicator_level2 80
#property indicator_levelcolor DimGray
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    KPeriod          = 7;
extern int    DPeriod          = 3;
extern int    Slowing          = 3;
extern int    SignalMaMode     = MODE_SMA;
extern bool   UseSignalLine    = false;
extern string Timeframe1       = "15";
extern string Timeframe2       = "h1";
extern string Timeframe3       = "h4";
extern bool   ShowOnlyWallabys = false;

//
//
//
//
//

double Wallabys[];
double Stoch1[];
double Stoch2[];
double Stoch3[];
bool   returnBars;
string indicatorFileName;
int    TimeFrame1;
int    TimeFrame2;
int    TimeFrame3;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int style = DRAW_LINE;
      if (ShowOnlyWallabys) style = DRAW_NONE;

      //
      //
      //
      //
      //
         
      SetIndexBuffer(0, Stoch1);   SetIndexLabel(0, "Stochastic 1"); SetIndexStyle(0,style);
      SetIndexBuffer(1, Stoch2);   SetIndexLabel(1, "Stochastic 2"); SetIndexStyle(1,style);
      SetIndexBuffer(2, Stoch3);   SetIndexLabel(2, "Stochastic 3"); SetIndexStyle(2,style);
      SetIndexBuffer(3, Wallabys); SetIndexLabel(3, "Wallabys");
         TimeFrame1        = stringToTimeFrame(Timeframe1);
         TimeFrame2        = stringToTimeFrame(Timeframe2);
         TimeFrame3        = stringToTimeFrame(Timeframe3);
         returnBars        = (KPeriod == -123456);
         indicatorFileName = WindowExpertName();
   IndicatorShortName(timeFrameToString(TimeFrame1)+","+
                      timeFrameToString(TimeFrame2)+","+
                      timeFrameToString(TimeFrame3)+" "+"Wallabys Stochastic (" + KPeriod + "," + DPeriod + "," +Slowing + ")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,y,limit,counted_bars=IndicatorCounted();

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);
          if (returnBars) { Wallabys[0] = limit; return(0); }
          if (TimeFrame1!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame1,indicatorFileName,-123456,3,0)*TimeFrame1/Period()));
          if (TimeFrame2!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame2,indicatorFileName,-123456,3,0)*TimeFrame2/Period()));
          if (TimeFrame3!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame3,indicatorFileName,-123456,3,0)*TimeFrame3/Period()));

   //
   //
   //
   //
   //
   
   int mode = MODE_MAIN; if (UseSignalLine) mode=MODE_SIGNAL;
   for (i=limit; i>=0; i--)
   {
      y = iBarShift(NULL,TimeFrame1, Time[i]);
            Stoch1[i] = iStochastic(NULL, TimeFrame1, KPeriod, DPeriod, Slowing, SignalMaMode, 0, mode, y);
      y = iBarShift(NULL,TimeFrame2, Time[i]);
            Stoch2[i] = iStochastic(NULL, TimeFrame2, KPeriod, DPeriod, Slowing, SignalMaMode, 0, mode, y);
      y = iBarShift(NULL,TimeFrame3, Time[i]);
            Stoch3[i] = iStochastic(NULL, TimeFrame3, KPeriod, DPeriod, Slowing, SignalMaMode, 0, mode, y);
            Wallabys[i] = (Stoch1[i] + Stoch2[i] + Stoch3[i]) / 3.0;
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);  
}