//+------------------------------------------------------------------+
//|                                                          ZLS.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern int Smoothing=15;
extern int K_Length1=18;
extern int D_Slowing1=3;
extern int D_Length1=3;
extern int Method1=0;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern int PriceField1=0;  // 0 - Low/High, 1 - Close/Close
extern double Weight1=0.05;

extern int K_Length2=21;
extern int D_Slowing2=5;
extern int D_Length2=3;
extern int Method2=0;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern int PriceField2=0;  // 0 - Low/High, 1 - Close/Close
extern double Weight2=0.1;

extern int K_Length3=34;
extern int D_Slowing3=8;
extern int D_Length3=3;
extern int Method3=0;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern int PriceField3=0;  // 0 - Low/High, 1 - Close/Close
extern double Weight3=0.16;

extern int K_Length4=55;
extern int D_Slowing4=13;
extern int D_Length4=3;
extern int Method4=0;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern int PriceField4=0;  // 0 - Low/High, 1 - Close/Close
extern double Weight4=0.26;

extern int K_Length5=89;
extern int D_Slowing5=21;
extern int D_Length5=3;
extern int Method5=0;  // 0 - SMA
                       // 1 - EMA
                       // 2 - SMMA
                       // 3 - LWMA
extern int PriceField5=0;  // 0 - Low/High, 1 - Close/Close
extern double Weight5=0.43;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

double K[], D[], trend[];
double SmoothConst;
double SumWeight;

int init()
{
  IndicatorBuffers(3);
  SetIndexBuffer(0,K);
  SetIndexBuffer(1,D);
  SetIndexBuffer(2,trend);
  SmoothConst=(Smoothing-1.)/Smoothing;
  SumWeight=Weight1+Weight2+Weight3+Weight4+Weight5;
  IndicatorShortName("Zero Lag Stochastic");
 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
 
 for(pos=limit; pos>=0; pos--) 
 {
    double Stoch1=Weight1*iStochastic(NULL, 0, K_Length1, D_Length1, D_Slowing1, Method1, PriceField1, MODE_MAIN, pos);
    double Stoch2=Weight1*iStochastic(NULL, 0, K_Length2, D_Length2, D_Slowing2, Method2, PriceField2, MODE_MAIN, pos);
    double Stoch3=Weight1*iStochastic(NULL, 0, K_Length3, D_Length3, D_Slowing3, Method3, PriceField3, MODE_MAIN, pos);
    double Stoch4=Weight1*iStochastic(NULL, 0, K_Length4, D_Length4, D_Slowing4, Method4, PriceField4, MODE_MAIN, pos);
    double Stoch5=Weight1*iStochastic(NULL, 0, K_Length5, D_Length5, D_Slowing5, Method5, PriceField5, MODE_MAIN, pos);
  
    K[pos]=(Stoch1+Stoch2+Stoch3+Stoch4+Stoch5)/SumWeight;
    D[pos]=K[pos]/Smoothing+D[pos+1]*SmoothConst;
    trend[pos] = trend[pos+1];
    if (K[pos]>D[pos]) trend[pos] = 1;
    if (K[pos]<D[pos]) trend[pos] =-1;
   } 
 
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert(" crossed signal up");
      else  doAlert(" crossed signal down");       
    }         
 return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ZLS ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ZLS "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

